/*
**
**		block.c
**
*/
#define Simple
#define RLT8
#define IMQ

#include "mpeg.h"
extern int cnt;
extern int length;

#ifdef RLT8
#define SB 24
static int RL[256];
static int table0[256];
static int table1[ 16]={ 36,43,40,35,38,42,48,47,
			 34,46,45,37,39,33,41,44 };
static int table2[  8]={ 32,29,25,27,26,31,30,28 };
static Ui RLL0[256];
static Ui RLL1[16];
static Ui RLL2[8];
#else
#define SB 16
static Uc RL[65536];
#endif
static Ui RLL[113];

void
init_rlt(void)
{
	int i,j;
#ifdef RLT8
	for(j=4;j<256;j++){		/* first 8bit */
		unsigned int bf= j;
		for(i=0;i<25;i++)
			if((bf>>(8-Len[i])) == Cod[i])break;
		if(i<25) RL[j]= i;
		  else   RL[j]= 0;
	}
	RL[0]= 128; RL[1]= 129;
	RL[2]= 130; RL[3]= 131;
	for(j=0;j<256;j++){		/* next 8bit */
		unsigned int bf= j;
		for(i=49;i<113;i++)
			if((bf>>(16-Len[i])) == Cod[i])break;
		if(i<113) table0[j]= i;
		  else    table0[j]= 0;
	}
	for(i=0;i<256;i++){
		j= table0[i];
		RLL0[i]= Run[j]<<16 | Lev[j]<<8 | (Len[j]+1);
	}
	for(i=0;i<16;i++){
		j= table1[i];
		RLL1[i]= Run[j]<<16 | Lev[j]<<8 | (Len[j]+1);
	}
	for(i=0;i<8;i++){
		j= table2[i];
		RLL2[i]= Run[j]<<16 | Lev[j]<<8 | (Len[j]+1);
	}
#else
	for(j=0;j<65536;j++){		/* 16 bit */
		unsigned int bf= j;
		for(i=0;i<113;i++)
			if((bf>>(16-Len[i])) == Cod[i])break;
		if(i<113) RL[j]= i;
		  else    RL[j]= 0;
	}
#endif
	for(i=1;i<113;i++)Len[i]++;/* Lengths are incremented by 1 for s*/

	for(i=0;i<113;i++)		/* Second run level table */
		RLL[i]= Run[i]<<16 | Lev[i]<<8 | Len[i];
}

unsigned char diqm[64]={
  8, 16, 19, 22, 26, 27, 29, 34,
 16, 16, 22, 24, 27, 29, 34, 37,
 19, 22, 26, 27, 29, 34, 34, 38,
 22, 22, 26, 27, 29, 34, 37, 40,
 22, 26, 27, 29, 32, 35, 40, 48,
 26, 27, 29, 32, 35, 40, 48, 58,
 26, 27, 29, 34, 38, 46, 56, 69,
 27, 29, 35, 38, 46, 56, 69, 83	
};

unsigned char iqm[64];
unsigned char nqm[64];

#ifdef IMQ
static unsigned short iqmq[32][64];
static unsigned short nqmq[32][64];

void
init_qmq()
	{
	int i,j;
	for(i=0;i<64;i++){
		nqmq[1][i]=nqm[i];
		iqmq[1][i]=iqm[i];
		}
	for(j=2;j<32;j++){
		for(i=0;i<64;i++){
			iqmq[j][i]=iqmq[j-1][i]+iqm[i];
			nqmq[j][i]=nqmq[j-1][i]+nqm[i];
			}
		}
	}
#else
void
init_qmq(){}
#endif




void
clr_oce(int *p)
{
	int i= 64*sizeof(int)/sizeof(Ul)/8;
	do{
		p[0]= 0; p[1]= 0; p[2]= 0; p[3]= 0;
		p[4]= 0; p[5]= 0; p[6]= 0; p[7]= 0;
		p+= 8;
	}while(--i);
}

static int  leny[9]={3,2,2,3,3,4,5,6,7};
static int  cody[9]={4,0,1,5,6,14,30,62,126};
static int lenuv[9]={2,2,2,3,4,5,6,7,8};
static int coduv[9]={0,1,2,6,14,30,62,126,254};

#ifdef IMQ
Ui
block(b,oce,ni,qmq)
int	oce[64];
unsigned short *qmq;
#else
Ui
block(b,oce,ni,qp,qm)
int	oce[64];
Uc	*qm;
#endif
	{
	int	i,r,ind,t;
	int cola= 0;
	void sys(void);

	clr_oce(oce);

	if(ni==0){
		if(b<4) i= vld( cody, leny,9, "dct dc size luma");
		 else   i= vld(coduv,lenuv,9, "dct dc size chroma");
		if(i){ t= buf>>31; r= fld( i, "dct dc code");
			if(t==0) r-= (1<<i)-1; }
		 else r= 0;
		if(b< 4)r= lasty+= r;
		else if(b==4)r= lastu+= r;
		else /*if(b==5)*/r= lastv+= r;
		oce[0]= r<<3;
if(prdc)fprintf(stderr,"DC coef %d\n",r);
		if(ptyp==4) return 0;
		cola= i= 1;
		}
	else if((i= buf>>31)){
		t= 3;
#ifdef IMQ
		t*= qmq[0];
#else
		t*= qp*qm[0];
#endif
		t= -(t>>4)|1;
		if(fld(2,"dct coeff first")==2) t= -t;
		oce[0]= t;
if(prrl)fprintf(stderr,"first coef( run=0 level=1 )\n");
		cola= 1;
		}

	while((ind=RL[buf>>SB])){
		register int run,level,s;
		if(ind==16){
			t= fld(20,"escape6+run6+level8");
			run= (t>>8)&63;
			level= t&255;
			s= level>=128;
			if((level&0x7f)==0) level= fld(8,"level2");
			if(s)level= 256-level;
			level<<=1;
			}
		 else{
			Ui t;
#ifdef RLT8
			if(ind>=128) switch(ind){
			case 128: t= RLL0[ buf>>16 ]; break;
			case 129: t= RLL1[(buf>>(32-12))-16]; break;
			default:  t= RLL2[(buf>>(32-10))- 8];
				}
			else
#endif
			t= RLL[ind];
			run= t>>16; level= (Uc)(t>>8);

{			/* s= fld((Uc)t,"run-level 2d+s")&1; */
int     j,bit= (Uc)t,res;
j= 8-(bs8&7); bs8 += bit;
s= (buf>>(32- bit))&1;
while(bit>=j){
	buf<<=j; bit-= j; j= 8;
	if(length-- ==0) sys();
	if((res=getc(bs))==EOF) { if(cnt++>=0)longjmp(jpb,2); }
	 else buf|= res;
	}
buf<<=bit;
}
			}

#ifdef Debug
if(prrl)fprintf(stderr,"run=%d level= %d\n",run,level>>1);
#endif

		r= level|ni;
		t= Zz[i+=run];
		i++;
		/*
		if(i>64) longjmp(jpb,1);
		*/
		cola|= 1<<(t&7);
#ifdef IMQ
		r*= qmq[t];
#else
		r*= qp*qm[t];
#endif
#ifdef	Simple
		r= r>>4;
		if(s)r= -r;
#else
		r= -(r>>4)|1;
		if(s) {     if(r< -2048) r= -2048; }
		 else { r= -r;if(r>2047) r=  2047; }
#endif
		oce[t]= r;
		}

{	/* r= fld(2,"eob"); */
int     j,bit= 2,res;
j= 8-(bs8&7); bs8 += bit;
while(bit>=j){
	buf<<=j; bit-= j; j= 8;
	if(length-- ==0) sys();
	if((res=getc(bs))==EOF){ if(cnt++>=0)longjmp(jpb,2); }
	 else buf|= res;
	}
buf<<=bit;
}

if(prrl)fprintf(stderr,"--eob--\n");
	
	return cola;
	}

void
blocklayer(int mb,int intra,int qp,Uc pre[6][64])
{
	static int past_intra_address;
	int b,cbp,ni;
	unsigned short *q;

	if (intra){
		if(mb - past_intra_address > 1) lasty=lastu=lastv= 128;
		past_intra_address= mb;
		cbp= 63;
		q= iqmq[qp];
		ni= 0;
	} else {
		//cbp= vld( CdCBP, VlcCBP, 64, "cbp");
		if((buf>>(32-8))>=4) {
			 cbp= cbpt[buf>>(32-8)];	// 256 byte table
			 fld(VlcCBP[cbp],"cbp");
		} else {
			cbp= cbpt2[buf>>(32-9)];	// with 8 byte table
			//if(cbp==0) s_err();
			fld(9,"cbp");
		}
		q= nqmq[qp];
		ni= 1;
		if(prcbp)fprintf(stderr,"cbp=%x\n",cbp);
	}

	for(b=0;b<6;b++) if(cbp&(32>>b)) {
		int *oce= calloc(64,sizeof(int));
		Ui cola= block(b,oce,ni,
#ifdef IMQ
		q);
#else
		qp,iqm);
#endif
		if(pdct)qdct(oce,(Ul*)pre[b],intra,cola);
		 else   idct(oce,(Ul*)pre[b],intra,cola);
		free(oce);
	}
	if(intra && ptyp==4)fld(1,"end_of_macroblock");
}

#ifdef Long64
static Ul p1=  257L<<48 | 257L<<32 | 257L<<16 | 257L;
static Ul n1=~(257L<<48 | 257L<<32 | 257L<<16 | 257L);
#else
static Ui p1=  257<<16 | 257;
static Ui n1=~(257<<16 | 257);
#endif

static Ul	pro[6*64/sizeof(Ul)];

void
mcsel(int h,int v,MV vp,MV vn,Ul *pre,int dir)
{
	int i;
	Ul a,b,*pt;

	if(ffp){ vp.x<<=1; vp.y<<=1; }
	if(bfp){ vn.x<<=1; vn.y<<=1; }

	switch(dir){
	case 1: mc_mb((Uc*)fsif, h, v, vp,(Uc*) pre); break;
	case 2: mc_mb((Uc*)bsif, h, v, vn,(Uc*) pre); break;
	case 3: mc_mb((Uc*)bsif, h, v, vn,(Uc*) pre); 
		mc_mb((Uc*)fsif, h, v, vp,(Uc*) pro);
		pt= pro;
		i=6*64/4/sizeof(Ul);
		do{	a= pt[0]; b= pre[0];
			pre[0] = ( (a&n1)>>1 )+( (b&n1)>>1 ) + ((a|b)&p1);
			a= pt[1]; b= pre[1];
			pre[1] = ( (a&n1)>>1 )+( (b&n1)>>1 ) + ((a|b)&p1);
			a= pt[2]; b= pre[2];
			pre[2] = ( (a&n1)>>1 )+( (b&n1)>>1 ) + ((a|b)&p1);
			a= pt[3]; b= pre[3];
			pre[3] = ( (a&n1)>>1 )+( (b&n1)>>1 ) + ((a|b)&p1);
			pre+= 4; pt+= 4;
		} while(--i);
	}
}
