/*
**	chcmap.c
**
*/
#include <stdio.h>
#include <string.h>
#include "mpeg.h"
#include "disp.h"

int contrast=50;
int bright=50;
int saturation=50;
int hue=50;

int sint;
int cost;

int cmp,ddt,exc;

Visual *vis;
int dep,scr;
Display *dpy;
Colormap map, dmap;
Window	w1;
XColor c1;
XVisualInfo vinfo;

int	fg_pix;
int	bg_pix;
int	grid= 0;
int	cmr[CN];
int	cmg[CN];
int	cmb[CN];

Clp Q;

#define clip(t) if(t<0)t=0;if(t>255)t=255

void
init_clip(void)
{
	int i,t;
	for(i= -256;i<512;i++){
	t= i; clip(t); Q.cl[i]= t; Q.sq[i]= i*i;
	}
}

Visual *
FindFullColorVisual (dpy, scr, dep)
Display *dpy;
int *dep;
{
  XVisualInfo *vinfo_ret;
  XVisualInfo vinfo;
  int numitems, maxdep;
  
  vinfo.class = TrueColor;
  vinfo_ret = XGetVisualInfo(dpy, VisualClassMask, &vinfo, &numitems);
  if (numitems == 0) return NULL;

  maxdep = 0;
  while(numitems > 0) {
    if (vinfo_ret[numitems-1].depth > maxdep) {
      maxdep = vinfo_ret[numitems-1 ].depth;
    }
    numitems--;
  }
  XFree(vinfo_ret);
  if (maxdep < 0) return NULL;
  if (XMatchVisualInfo(dpy, scr, maxdep, TrueColor, &vinfo)) {
    *dep = maxdep;
    return vinfo.visual;
  }
  return NULL;
}


void
color_map_set(bgonly,gdonly)
	{
	int j,y,u,v,r,g,b;
	int begin,end;
	static int new=1;

	if(ddt==FullColor)return;
	if(new){
		new= 0;
		dmap= DefaultColormap(dpy,scr);
		map=  XCreateColormap(dpy,w1,vis,1);
		c1.flags= DoRed|DoGreen|DoBlue;
		}

	if(gdonly) { begin= fg_pix; end= fg_pix+1; }
	else if(bgonly){ begin= 0; end= ICN; }
	else	       { begin= 0; end= 256; }

	for(j=begin;j<end;j++){
		c1.pixel= j;
		if(j<ICN && exc!=1){
			if(exc==0) XQueryColor(dpy,dmap,&c1);
			if(exc==2) c1.red=c1.green=c1.blue= 0;
			if(exc==3) c1.red=c1.green=c1.blue= j<<11;
			}
		else switch(ddt){
	case 8: r=g=b=j; goto save_cm;
	case 4:
	case 0: case 3: case 5: case 6: case 7:
		r= (j&0xe0)+16;
		g= ((j&0x1c)<<3)+16;
		b= ((j&3)<<6)+32;
	save_cm: cmr[j]= r; cmg[j]= g; cmb[j]= b;
		goto RGb;
	case 2:
		u= (j&0xc0)-128;
		v= ((j&0x30)<<2)-128;
		y= ((j&0xf)<<4);
		Yuvrgb() goto RGB;
	case 1: r= cmr[j]; g= cmg[j]; b= cmb[j];
	RGb:	Rgbrgb()
	RGB:	if(j==ICN) r=g=b=0;
		c1.red= r<<8; c1.green= g<<8; c1.blue=  b<<8;
		}
		if(j==fg_pix && grid) c1.red= c1.green= c1.blue= 255<<8;
		XStoreColor(dpy,map,&c1);
		}
	/*
	XInstallColormap(dpy,map);
	*/
	XSetWindowColormap(dpy,w1,map);
	XFlush(dpy);
	}

int
chcmap(int argc, char **argv)
{
	argc--;
        while (argc) {
		     if (strncmp(argv[1],"-b",2)==0)bright= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-c",2)==0)contrast= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-s",2)==0)saturation=atoi(argv[1]+2);
		else if (strncmp(argv[1],"-h",2)==0)hue= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-D",2)==0)ddt= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-B",2)==0)exc= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-C",2)==0)cmp= atoi(argv[1]+2);
		else if (strncmp(argv[1],"-W",2)==0)sscanf(argv[1]+2,"0x%x",(Ui*)&w1);
		else break;
		argc--; argv++;
	}

	ddt= FullColor;
	if(vis==NULL || dep<=8){
		if(XMatchVisualInfo(dpy,scr,8,PseudoColor,&vinfo)) {
			vis = vinfo.visual;
			ddt= 0;
		}
		else { fprintf(stderr,"Requires 8 bit PseudoColor visual\n"); exit(1); }
	}

#ifdef	DEBUG
	fprintf(stderr, "w:%d ddt:%d exc:%d cmp:%d :: c:%d b:%d s:%d h:%d\n",
		w1, ddt, exc, cmp, contrast, bright, saturation, hue); 
#endif
	bright= (bright-50)*((1<<22)/50);
	contrast= contrast*((1<<16)/50);
	cost= saturation*cos((hue-50)/50.)*((1<<16)/50);
	sint= saturation*sin((hue-50)/50.)*((1<<16)/50);
	color_map_set(0,0);
	return 0;
}

int
main(int argc,char **argv)
{
	char buf[256];

	unlink(argv[0]);

	init_clip();
	dpy=    XOpenDisplay("");
	if(dpy == NULL){ fprintf(stderr,"Can not open display\n"); exit(1); }
	scr=    DefaultScreen(dpy);
	dep=    DisplayPlanes(dpy,scr);
	vis=    DefaultVisual(dpy,scr);
	fg_pix= WhitePixel(dpy,scr);
	bg_pix= BlackPixel(dpy,scr);
	vis= FindFullColorVisual (dpy, scr, &dep);

	if (argc > 1) chcmap(argc, argv);
	else	while (gets(buf)) {
			int	argc = 0;
			char	*argv[100];

			for (argv[argc] = strtok(buf, " \t"); argv[argc];) {
				argv[++argc] = strtok(NULL, " \t");
		}
		chcmap(argc, argv);
	}
	return 0;
}
