/*
**	dec.c
**	mpeg1 decoder for single sequence
**
*/
#include "mpeg.h"
#include <sys/types.h>
#include <dirent.h>

extern int stop_now;
extern int back;
extern int halt;
extern int back2;
extern int for2;
/* multiple sequence  main() for ui.c */
int	fc,argc;
char	**fv;
long	flen;


#define	SEQ	0xb3
#define	GOP	0xb8
#define	SQE	0xb7
#define PIC	0x00
#define	SLS	0x01
#define	SLE	0xaf
#define	EXT	0xb5
#define	USR	0xb2
/*
**	0xb9 to 0xff:    systems start codes
**
**	0xb9: ISO_11172_end_code
**	0xba: pack_start_code
**	0xbb: system_header_start_code
**
**	0xbc: reserved stream
**	0xbd: private_stream_1
**	0xbe: inserted_stream
**	0xbf: private_stream_2
**	0xcX and dX: ISO/IEC 11172-3 audio stream
**	0xeX: ISO/IEC 11172-2 Video stream
**	0xfx: reserved_data_stream
**
*/

#ifdef Debug
int	pr;
int	prsl;
int	pri;
int	prp;
int	prb;
int	prd;
int	prcbp;
int	prdc;
int	prrl;
int	prc;
int	error_detect;
static int last_sh_pos;
static int last_p_pos;
#endif
int	gx;
int	gy;
int	ddt;
int	x2=   1;
int	pdct;
int	cmp;
int	bgc;
int	sync1= 1;
int	wid;
int	times= 1;
int	etimes= 1;
int	tmfsq=1;
int	frame;
int	srsqh;
double	cur;	/* current time	*/
static double appo, term;
static int audio= 0;
static int broken_link;
int broken_link2;
static int closed_gop;

jmp_buf jpb;

char	*fsif;
char	*bsif;
char	*osif;
char 	*out;
char 	*wsif;
int	ptyp;
int	lasty,lastu,lastv;
int	dhs,dvs;
int	hs,vs,vhs;
int	ffp,bfp;

static int sosif;
static int	h,v;
static MV	Zv;
static int	ff,bf;
static Ul	pre[6*64/sizeof(Ul)];
static char	bsname[128]="stdin";
FILE	*bs;
static int	dir;
static MV	PMV1,PMV2;
static int	init;
static int	stop;
static double	startt;
#ifdef Beta
static double expire;
#endif
static int	prt=4;
static double	pic_term[16]={
	1./30, 1.001/24, 1./24, 1./25,
	1.001/30, 1./30, 1./50, 1.001/60,
	1./60, 1./30, 1./30, 1./30,
	1./30, 1./30, 1./30, 1./30
	};
static int itt[11]={ 0,0,0,0,0,0,1,0,0,0,1 };
static int cdt[11]={ 0,1,0,1,0,1,1,1,1,1,1 };
static int drt[11]={ 3,3,2,2,1,1,0,3,1,2,0 };

/*
**	system decoder
*/
#define BL 2048
static char ar[BL];
int length;
int sysbs;

void getnc(n){ do{getc(bs);}while(--n); }
int get2c(){int t=getc(bs);return(t<<8|getc(bs));}

void sys()
{
	int t,n,stc,w,len;
	while(1){
	do{
	  do{ t= getc(bs); if(t==EOF) longjmp(jpb,2); } while(t);	// !=0
	  do{ t= getc(bs); } while(!t);					// ==0
	  }while(t-1);							// ==1?
	stc= getc(bs);					// start code 4th byte
	if(stc==0xb9 || stc==EOF) longjmp(jpb,2);	// ISO_11172_end_code or EOF
	if(stc< 0xb9){ sysbs= 0; length= -1; buf= 256; ungetc(stc,bs); return; } // video
	sysbs= 1;
	w= len= 0;
	if(stc==0xbf) continue;				// private_stream_2
	if(stc==0xba) { getnc(8); continue; }		// pack_start_code
	len= get2c();
	if(stc==0xbb){ getnc(len); continue; }		// system_header_start_code

	do { t= getc(bs); len--; }while(t==255);
	if((t>>(8-2))==1){ getc(bs); t= getc(bs); len-=2; }
	if((t>>(8-4))==2){ getnc(4); len-= 4; }
	else if((t>>(8-4))==3){ getnc(9); len-= 9; }
	if(stc>=0xe0&&stc<0xf0){ length= len-1; return; } // return video
	if(stc>=0xc0&&stc<0xe0 && audio) w= 1;
	//do{ t= getc(bs); if(t==EOF) longjmp(jpb,2); if(w) putchar(t); } while(--len);
	while(len){
		int l=len; if(len>BL)l= BL;
		if(!(n=fread(ar,1,l,bs))) longjmp(jpb,2);
		if(w && write(1,ar,n)== -1){ fprintf(stderr,"stdout err\n"); exit(1); }
		len-= n;
	}
	}
}

/*
** read system clock
*/
double
ReadSysClock()
{
  struct timeval tv;
  (void) gettimeofday(&tv, (struct timezone *)NULL);
  return (tv.tv_sec + tv.tv_usec / 1000000.0);
}


Ui buf;
Ui bs8;
#ifndef Debug
static char cp[10]={"vld"};
#endif
int cnt= -4;
/*
**	fixed length code decoder
**	for bit <=24 and for byte aligned codes bit<=32
*/
int
fld(int bit,char *cp)
{
	int	j,code,res;

	j= 8-(bs8&7); bs8 += bit;
	code= buf>>(32- bit);

if(prc)fprintf(stderr,"fld: %s len= %d cod=%d\n", cp, bit, code);

	while(bit>=j){
		buf<<=j; bit-= j; j= 8;
		if(length-- ==0) sys();
		if((res= getc(bs))<0 && cnt++>=0)longjmp(jpb,2);
		 else buf|= res;
	}
	buf<<=bit;
	return code;
}

int
start_code(void)
	{
	if(bs8&7) fld(8-(bs8&7),"next bit");
	while(buf>=512)fld(8,"next");
	while(buf<   2)fld(8,"zero_byte");
	return fld(32,"Start Code")&255;
	}

int
vld(int *tcde,int *tbit,int maxi,char *tname)
{
	register int	i,code;
	

	for(i=0;i<maxi;i++)
		if((buf>>(32-tbit[i])) == tcde[i])break;
	if(i<maxi) code= fld(tbit[i],"");
	 else {
		if(error_detect){
		fprintf(stderr,"%s not found(buf=%08x)\n", tname,buf);
#ifdef Debug
	fprintf(stderr,"vbit=%d fr=%d fpos=%ld\n", bs8,frame,ftell(bs));
	fprintf(stderr,"last_sh_pos= %d (%x)last_p_pos=%d(%x)\n",
			last_sh_pos,last_sh_pos, last_p_pos,last_p_pos);
#endif
			exit(1);
		}
		 else	longjmp(jpb,1);
	}
	if(prc)fprintf(stderr,
	"vld: %s code= %x, len=%d, index=%d\n", tname, code, tbit[i], i);
	return i;
}


int
seq() {
	int	i;
	void iwt();
	void init_qmq();

	if(pr)fprintf(stderr,"video sequence start\n");

#ifdef Debug
	last_sh_pos= ftell(bs);
#endif

	if(init){
		dhs= fld(12, "horizontal size");
		dvs= fld(12, "vertical size");
		if(pr)fprintf(stderr,"%dx%d\n",dhs,dvs);
		hs= ((dhs+15)>>4)<<4;
		vs= ((dvs+15)>>4)<<4;
		vhs= hs*vs; if(vhs==0) return start_code();
		sosif= vhs+(vhs>>1);
		init= 0;
		if(fsif) free(fsif);
		fsif= malloc(sosif);
		if(bsif) free(bsif);
		bsif= malloc(sosif);
		if(osif) free(osif);
		osif= malloc(sosif);
		strcat(bsname,(sysbs)?" (sys)":" (vid)");
		if(ddt<90)iwt(bsname,bsif,dhs,dvs);
		startt = ReadSysClock();
	}
	else fld(24, "hsize(12),vsize(12)");

	i=fld(27, "par(4),picture rate(4),bitrate(18),reserved bit(1)");
	prt= (i>>19)&15;
	fld(11,	"buffer size[16kbit](10),constraint parameter flag(1)");
	if( fld(1, "load intra quant matrix") )
		for(i=0;i<64;i++) iqm[Zz[i]]=fld(8,"intra qm");
	 else for(i=0;i<64;i++) iqm[i]= diqm[i];
	if( fld(1, "load non intra quant matrix") )
		for(i=0;i<64;i++) nqm[Zz[i]]=fld(8,"non intra qm");
	 else for(i=0;i<64;i++) nqm[i]= 16;
	init_qmq();
	return start_code();
}

int
gop() {
	int t;
	if(pr)fprintf(stderr,"gop start\n");
	t= fld(27,"time code+closed_gop+broken_link" );
	broken_link= t&1;
	closed_gop= (t>>1)&1;
	return start_code();
}

void
wimg(char *sif)
{
	void wt();
#ifdef Debug
	char fname[128];
#endif
	static int lastsync= 0;

	if(startt==0) exit(0);
	cur= ReadSysClock();
#ifdef Beta
	if(cur>=expire){
		fprintf(stderr,"Test version is restricted to 30 min.\n");
		exit(1);
	}
#endif
	if(sync1){
		if(sync1 != lastsync) {
			term= pic_term[prt]*sync1;
			appo= cur + term;
		} else {
			if(cur<appo) usleep((Ui)((appo-cur)*500000.));
			appo+= term;
		}
	}
	lastsync= sync1;
loop:
	if(ddt<90)wt(sif,bsname);
#ifdef Debug
	else if(ddt==98&&audio==0){
		FILE *fp;
		sprintf(fname,"%s%05d.sif",bsname,frame);
		fp= fopen(fname,"w");
		fwrite(sif,1,sosif,fp);
		fclose(fp);
	if( write(1,sif,sosif) == -1 ){
		fprintf(stderr,"stdout err\n");
		exit(1);
	}
}
#endif
	if(halt){
		usleep(200000);
		cur= ReadSysClock();
		lastsync= 0;
		goto loop;
	}
	if(++frame==stop) while(1)usleep(100000);
}

int
pic()
{
	int t;
	static int start= 1;
#ifdef Debug
	last_p_pos= ftell(bs);
#endif
	if(wsif)wimg(wsif);
	fld(10, "temporal reference");
	ptyp= fld(3, "ptype"); if(ptyp<1 || ptyp>4) return start_code();
	if(pr)fprintf(stderr,"picture ptype= %d start\n", ptyp);
	fld(16, "vbv_delay");
	if(ptyp==2||ptyp==3){
		t= fld(4,"full_pel_forward(1)+forward_f_code(3)");
		ffp= t>>3; ff= t&7;
		if(ff==0)longjmp(jpb,1);
	}
	if(ptyp==3){
		t= fld(4,"full_pel_backward(1)+backward_f_code(3)");
		bfp= t>>3; bf= t&7;
		if(bf==0)longjmp(jpb,1);
		wsif= out= osif;
		if((broken_link && !closed_gop) || broken_link2)wsif= NULL;
	 }else{
		out= fsif; wsif= fsif= bsif; bsif= out;
		 if(start) wsif= NULL; 
		 start= 0;
		 if(ptyp==2) broken_link= broken_link2= 0;
	}
	while(fld(1,"pei"))fld(8,"...");
	return start_code();
}

MV mv_decode(MV mv,int fc)
{
	int	v, s, t;
	fc--; t= 27-fc;
#ifdef NMVT
	if(!fld(1,"mv0")) {
		v= buf>>(32-9); if(v<256) v= mvht[v]; else v= 0; // 256b
		s= fld(VlcMVH[v]+1, "mvh")&1; v= (v<<fc)+1;
		if(fc) v+= fld(fc,"res"); mv.x+= (s)?-v:v; mv.x= (mv.x<<t)>>t;
	}
	if(!fld(1,"mv0")) {
		v= buf>>(32-9); if(v<256) v= mvht[v]; else v= 0; // 256b
		s= fld(VlcMVH[v]+1, "mvh")&1; v= (v<<fc)+1;
		if(fc) v+= fld(fc,"res"); mv.y+=(s)?-v:v; mv.y= (mv.y<<t)>>t;
	}
#else
	if(buf>>31)fld(1,"mv0");
	else {
		v= (vld(CdMVH,VlcMVH,16,"mv v")<<fc)+1; s= fld(1,"mvs");
		if(fc) v+= fld(fc,"res"); mv.x+=(s)?-v:v; mv.x= (mv.x<<t)>>t;
	}
	if(buf>>31)fld(1,"mv0");
	else {
		v= (vld(CdMVH,VlcMVH,16,"mv v")<<fc)+1; s= fld(1,"mvs");
		if(fc) v+= fld(fc,"res"); mv.y+=(s)?-v:v; mv.y= (mv.y<<t)>>t;
	}
#endif
	return mv;
}

int
macroP(int mb,int h,int v,int mq)
{
	int	mt,intra;
	MV	vp;
	
	mt= vld(CdBT1,VlcBT1,7,"MBT1");
	//mt= mbtt[1][buf>>(32-6)]; fld(VlcBT1[mt],"MBT2");

	if(mt>=4) mq= fld(5,"quantizer scale");
	intra= (mt==3||mt==6);
	dir=   (mt==0||mt==2||mt==4);
	/*
	dir=   ((mt&1)==0&&mt!=6)?1:0;
	dir=   ((mt&1)||intra)?0:1;
	*/
	
	if(dir){
		PMV1= vp= mv_decode(PMV1, ff);
		if(ffp){ vp.x<<=1; vp.y<<=1; }	
		mc_mb((Uc*)fsif, h, v, vp,(Uc*)pre);
	} else {
		PMV1= Zv; 
		if(intra==0) mc_mb((Uc*)fsif, h, v, Zv,(Uc*)pre);
	}

	if(prp){
		fprintf(stderr,"h=%d mt=%d mq=%d",h,mt,mq);
		if(dir)fprintf(stderr,"(%d,%d) ",PMV1.x,PMV1.y);
		fprintf(stderr,"\n");
	}

	if(mt!=2) blocklayer(mb,intra,mq,(Uc(*)[64])pre);
	save(v, h, pre);
	return mq;
}

int
macroB(int mb,int h,int v,int mq)
{
	int	mt;
	
	mt= vld(CdBT2,VlcBT2,11,"MBT2");
	//mt= mt= mbtt[2][buf>>(32-6)]; fld(VlcBT2[mt],"mbt");

	if(mt>=7) mq= fld(5,"quantizer scale");
	if((dir= drt[mt])){
		if(dir&1) PMV1= mv_decode(PMV1, ff);
		if(dir&2) PMV2= mv_decode(PMV2, bf);
		mcsel(h, v, PMV1, PMV2, pre, dir);
	}
	 else PMV1= PMV2= Zv; 
	if(prb){
		fprintf(stderr,"h=%d mt=%d mq=%d",h,mt,mq);
		if(dir&1)fprintf(stderr,"(%d,%d) ",PMV1.x,PMV1.y);
		if(dir&2)fprintf(stderr,"(%d,%d) ",PMV2.x,PMV2.y);
		fprintf(stderr,"\n");
	}
	if(cdt[mt]) blocklayer(mb,itt[mt],mq,(Uc(*)[64])pre);
	save(v, h, pre);
	return mq;
}

int
slice(pt)
{
	int	mq;
	int	mb,mba;
	mq= fld(5,"squant");

if(prsl)fprintf(stderr,"slice start v= %d sq= %d\n",v,mq);

	while(fld(1,"extra bit slice"))fld(8,"extra info slice");

	lasty= lastu= lastv= 128;
	PMV1= PMV2= Zv;
	mb= -1;
	do{	
		int t;
		mba= 1;
		while((buf>>(32-11))==15)fld(11,"macroblock stuffing");
		while((buf>>(32-11))==8){fld(11,"macroblock escape");mba+= 33;}
		//mba+= vld(CdMBA,VlcMBA,33,"macroblock address increment");
		t= buf>>(32-4);
		if(t>1) t= mba0[t];			// first 4 bit
		else    t= mba1[(buf<<3)>>(32-8)];	// 8 bit after 3 bit
		if(t<33){
			mba+= t; fld(VlcMBA[t], "mba"); // decided
		} else return start_code();

		if(mb<0){
			mb= 0;
			h= (mba-1)<<4;
			if(h>=hs) return start_code();
		} else {
	 		mb+= mba;
			h+=16; if(h>=hs){
				h=0; v+= 16;
				if(v>=vs) return start_code();
			}
			while(mba-->1){
				if(pt<=2){
					mc_mb((Uc*)fsif, h, v, Zv,(Uc*)pre); PMV1= Zv;
				}
				 else mcsel(h, v, PMV1, PMV2, pre, dir);
				save(v,h,pre);
				h+=16; if(h>=hs){
					h=0; v+= 16;
					if(v>=vs) return start_code();
				}
			}
	    }
		if(pt==3) mq= macroB(mb, h, v, mq);
		else if(pt==2) mq= macroP(mb, h, v, mq);
		else {
			int mt;
			if((mt=vld(CdBT0,VlcBT0,2,"MBT0")))
			//mt= mbtt[0][buf>>(32-6)]; fld(VlcBT0[mt],"mbt"); if(mt)
				mq= fld(5,"quantizer scale"); 
if(pri) fprintf(stderr,"h=%d mt=%d mq=%d\n",h,mt,mq);
			blocklayer(mb,1,mq,(Uc(*)[64])pre);
			save(v, h, pre);
		}
	} while(buf >= 512);
	return start_code();
}

void
dec_seq(times)
{
	int	stc=0;
	int	r;
	tmfsq= times;
	init= 1;
	do{
		srsqh= 1;
		cnt= -4; out= bsif; bs8= length= 0;
		stc= start_code();
	    do{
		r= setjmp(jpb);
		if(r==2) break; // From varnia of ui.c, video bs pool.mpg stopped. 
				///When the line changed to comment, it is halt.
		if(r==1) while(h<hs){
			mc_mb((Uc*)fsif, h, v, Zv,(Uc*)pre);
			save(v, h, pre);
			h+=16;
		}
		if(srsqh) while(stc!=SEQ) stc= start_code();
		srsqh= 0;
		if(stc==SEQ) stc= seq();
		else if(stc==GOP) stc= gop();
		else if(stc==PIC) stc= pic();
		else if(stc==EXT||stc==USR){
			while((buf>>8) != 1) fld(8, "ext or usr");
			stc= start_code();
		}
		else if(stc>=0xb9) break;
		else while(stc>=SLS && stc<=SLE){
			v= (stc-1)<<4;
			if(v<vs)stc= slice(ptyp);
			   else stc= start_code();
		}
		if(stop_now) { tmfsq=1; stop_now=0; break; }
	   }while(stc!=SQE);
	    if(fseek(bs,0L,SEEK_SET))break;
	}while(!tmfsq || --tmfsq>0);
	if(ptyp==3) if(osif)wimg(osif);
	if(bsif)wimg(bsif);
	if(fsif)free(fsif); if(bsif)free(bsif); if(osif)free(osif);
	wsif= fsif= bsif= osif= NULL;
}


int
test_mpg(char *c)
{
	int i; int dig_dir(char*c);
	Uc buf[16];
	//if(strlen(c)<=4 || strncmp(c+strlen(c)-4,".mpg",4)) return 0;
	if(!(bs= fopen(c,"r"))) { /*perror("fopen");*/ return 0; }
	i= fread(buf,1,16,bs);
	if(!i||buf[0]||buf[1]||buf[2]-1||(buf[3]-0xba&&buf[3]-0xb3)) { fclose(bs); dig_dir(c); return 0; }
	if(fseek(bs,0L,SEEK_END)) { /*perror("fseek");*/ fclose(bs); return 0; }
	flen= ftell(bs);
	if(fseek(bs,0L,SEEK_SET)) { /*perror("fseek");*/ fclose(bs); return 0; }
	strcpy(bsname,c);
	return 1;
}

int
dig_dir(char *c)
{
	struct dirent **namelist;
	int i,n;
	char **fv1;	// first file name pointer
	char **fv0= fv;	// save fv
	int fc0= fc;	// save fc
	int argc0= argc;// save argc

	n= scandir(c, &namelist, 0, alphasort);
	if (n<=2) { /*perror("fopen");*/ return 0; }
	fv1= fv= (char**)malloc(n*sizeof(char*));
	for(i=2;i<n;i++) {
		fv[i-2]= malloc(strlen(c)+1+strlen(namelist[i]->d_name)+1);
		sprintf(fv[i-2], "%s/%s", c, namelist[i]->d_name);
	}
	argc= n-2;
	fc= n-2; fv= fv1;
	do{
	    if(test_mpg(*fv)) dec_seq(times);
	    if(back){ if(fc== argc) break; else { back= 0; fc+=2; fv-=2; } }
	    if(back2){ back2= 0; back= 1; break; }
	    if(for2){ for2= 0; break; }
	} while (fv++,--fc);

	for(i=0;i<n;i++) free(namelist[i]);
	free(namelist);
	free(fv1);
	argc= argc0; fc= fc0; fv= fv0;	// retrieve
	return 1;
}

void
usage(char *p)
{
	printf("Cat's MPEG-1 Video decoder (version 1.07)\n");
	printf("Graphics controlled with mouse button 1 to 3 in window.\n");
	printf("usage: %s [-l][-x] ... [mpg files or dirs]\n",p);
	printf("-p: precisonal IDCT, -a: audio stream to stdout\n");
	printf("-l: loop in file(s), -xN: enlarged display size by NxN\n");
	printf("-b[0-3]: background color (pseudo color)\n");
	printf("-c[0,1]: color trim (pseudo color)\n");
	printf("-eN: exact framerate (def 1)\n");
	printf("-wN: no setting of colormap, N: window id\n");
	printf("-gxN: geometry x, -gyN: geometry y\n");
#ifdef Debug
	printf("-n: no display, -sN: stop at frame N  -tN: play N times\n");
	printf("-f: image file to stdout, -v: verbose, -sl: slice\n");
	printf("-ip -pp -bp: show mb info in I,P,B-pic\n");
	printf("-cbp:cbp -dc:intra dc, -rl:run-level\n");
	printf("-er:stop by error, -vc:vlc,flc\n");
	printf("-hN:N:decode from Nth sequence header\n");
#endif
	exit(1);
}

int
main(int c, char **v)
{
	char *v0= *v;
//	unlink(v0);	// remove self excutable file. use with gz. see Makefile
#ifdef Beta
	cur= ReadSysClock();
	expire= cur + 10*60;
#endif
	c--; v++;
	bs= stdin;
        while (c) {
		     if(!strcmp(*v,"-l")) times= etimes= 0;
		else if(!strcmp(*v,"-p")) pdct= 1;
		else if(!strcmp(*v,"-a")) audio= 1;
		else if(!strcmp(*v,"-h")) usage(v0);
#ifdef Debug
		else if(!strcmp(*v,"-n")) ddt=99;
		else if(!strcmp(*v,"-f")) ddt=98;
		else if(!strcmp(*v,"-v")) pr= 1;
		else if(!strcmp(*v,"-sl")) pr= prsl= 1;
		else if(!strcmp(*v,"-ip")) pri= pr= prsl= 1;
		else if(!strcmp(*v,"-pp")) prp= pr= prsl= 1;
		else if(!strcmp(*v,"-bp")) prb= pr= prsl= 1;
		else if(!strcmp(*v,"-cbp")) pr= prsl= prcbp= 1;
		else if(!strcmp(*v,"-dc")) pr= prsl= prcbp= prdc= 1;
		else if(!strcmp(*v,"-rl")) pr= prsl= prcbp= prrl= 1;
		else if(!strcmp(*v,"-vc")) pr= prsl= prcbp= prc= 1;
		else if(!strcmp(*v,"-er")) error_detect= 1;
		else if(!strncmp(*v,"-s",2)) stop= atoi(*v+2);
#endif
		else if(!strncmp(*v,"-t",2)) times= atoi(*v+2);
		else if(!strncmp(*v,"-x",2)) x2=   atoi(*v+2);
		else if(!strncmp(*v,"-c",2)) cmp=  atoi(*v+2);
		else if(!strncmp(*v,"-e",2)) sync1= atoi(*v+2);
		else if(!strncmp(*v,"-b",2)) bgc=  atoi(*v+2);
		else if(!strncmp(*v,"-d",2)) ddt=  atoi(*v+2);
		else if(!strncmp(*v,"-gx",3)) gx=  atoi(*v+3);
		else if(!strncmp(*v,"-gy",3)) gy=  atoi(*v+3);
		else if(!strncmp(*v,"-w",2)) wid= strtol(*v+2,0,0);
		else if(**v=='-') {
			fprintf(stderr, "unknown option: %s\n", *v); usage(v0);
		} else break;
		c--; v++;
	}
	init_rlt();
	if(c) do{
		argc= fc= c; fv= v;
		do{
			if(test_mpg(*fv)) dec_seq(times);
			if(back){ back= 0; if(fc< c) { fc+=2; fv-=2; } else { fv--; ++fc; } }
		} while (fv++,--fc);
	} while (!etimes||--etimes);
	else dec_seq(1);
	return 0;
}
