/*
**	disp.c
*/
#include "mpeg.h"
#include "disp.h"

/*
**
	m0   m1   m2   m3
	   c         c
	m4   m5   m6   m7

	m8   m9   ma   mb
	   c         c
	mc   md   me   mf
**
*/
#define M0	0
#define	M1	16
#define	M2	4
#define	M3	20
#define	M4	24
#define	M5	8
#define	M6	28
#define	M7	12
#define	M8	6
#define	M9	22
#define	MA	2
#define	MB	18
#define	MC	30
#define	MD	14
#define	ME	26
#define	MF	10

#define O 256
#define RGBD(l,M,S) (y=(l>>S)&255,(r[y+M-O]|g[y+M+O]|b[y+2*M-O])<<S)

void
disp01(Uc *sif)
{
Us *cb;
Ui *ip,*yp;
int	i,j,hx,wx;
int	wx2,hx2;
int y,u,v;
Ui h,n,l,m;
Ui *r,*g,*b;
Ui a,c;
int	brd=xys>>3;
static int inv= 0;

hx= dx>>2;
wx= wix>>2;
wx2= wx<<1;
hx2= hx<<1;
ip= (Ui *)dd;
yp= (Ui*)sif;
cb= (Us *)(sif+(xys>>2));

if(inv==0)
for(j=0;j<winh;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M0,24); n+= RGBD(m,M1,16);
		h = RGBD(l,M4,24); h+= RGBD(l,M5,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,M2,8); n+= RGBD(m,M3,0);
		h+= RGBD(l,M6,8); h+= RGBD(l,M7,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,M8,24); n+= RGBD(m,M9,16);
		h = RGBD(l,MC,24); h+= RGBD(l,MD,16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,MA,8); n+= RGBD(m,MB,0);
		h+= RGBD(l,ME,8); h+= RGBD(l,MF,0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
else
for(j=0;j<winh;j+=4){
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M0),24); n+= RGBD(m,(30-M1),16);
		h = RGBD(l,(30-M4),24); h+= RGBD(l,(30-M5),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-M2),8); n+= RGBD(m,(30-M3),0);
		h+= RGBD(l,(30-M6),8); h+= RGBD(l,(30-M7),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	i= wx;
	do{
		c= cb[brd];
		a= *cb++;
		u= (a>>8)&255; v= (c>>8)&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		l= yp[hx];
		m= *yp++;
		n = RGBD(m,(30-M8),24); n+= RGBD(m,(30-M9),16);
		h = RGBD(l,(30-MC),24); h+= RGBD(l,(30-MD),16);
		u= a&255; v= c&255;
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		n+= RGBD(m,(30-MA),8); n+= RGBD(m,(30-MB),0);
		h+= RGBD(l,(30-ME),8); h+= RGBD(l,(30-MF),0);
		ip[wx]= h;
		*ip++ = n;
		}while(--i);
	yp+= hx; ip+= wx;
	}
inv= 1-inv;
}
/*
**	4x4 RGB dither enlarged
*/
#define O 256
#define RGB(M) (r[y+M-O]|g[y+M+O]|b[y+2*M-O])
void
disp02(Uc *sif)
{
	Uc *cb;
	Us *yp;
	Ui *ip;
	int	i,j,hcs,wx;
	int	wx2,wx3;
	int	brd=xys>>2;
	int	y,u,v,d;
	Ui	*r,*g,*b;
	Ui	l,m,t;

	hcs= dx>>1;
	wx= wix>>2;
	wx2= wix>>1;
	wx3= wx2+wx;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<winh>>2;j++){
	for(i=0;i<winw>>2;i++){
		v= cb[i+brd];
		u= cb[i];
		r= Q.r+(v<<1); b= Q.b+(u<<1); g= Q.g-u-v;
		d= yp[i+hcs]; y= d>>8;
		t= RGB(MA);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M8);
		l|= t&0xffff; m|= t>>16;
		ip[i+wx3]= m;
		ip[i+wx2]= l;
		d= yp[i]; y= d>>8;
		t= RGB(M2);
		l= t<<16; m= t&0xffff0000;
		y= (Uc)d;
		t= RGB(M0);
		l|= t&0xffff; m|= t>>16;
		ip[i+wx]= m;
		ip[i] = l;
		}
		yp+= dx; ip+= wix;
		cb+= hcs;
	}
}

/*
**	4x4 RGB dither 4x4 enlarged
*/
#ifdef LE
#define Q0 0
#define Q1 1
#else
#define Q0 1
#define Q1 0
#endif
void
disp04(Uc *sif)
{
	Us *yp=(Us*)sif;
	Uc *cb;
	Ui *ip;
	int	i,j,hcs,wx,wy;
	int	wx2,wx3;
	int	crd=xys>>2;
	int	y,u,v;
	Ui	*r,*g,*b;
	Us	yy;
	Ui	l,m,t;

	hcs= dx>>1;
	wx=  wix>>2;
	wx2= wix>>1;
	wx3= wx2+wx;
	wy= winh>>2;
	ip= (Ui *)dd;
	cb= (Uc *)yp+xys;

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i+=2){
		v= cb[crd+(i>>1)];
		u= cb[(i>>1)];
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		yy= yp[i>>1];
		y= (Uc)yy;
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q0]= m; ip[wx2+i+Q0]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q0]= m; ip[i+Q0] = l;

		y= yy>>8;
		t= RGB(MA); l= t<<16; m= t&0xffff0000;
		t= RGB(M8); l|= t&0xffff; m|= t>>16;
		ip[wx3+i+Q1]= m; ip[wx2+i+Q1]= l;
		t= RGB(M2); l= t<<16; m= t&0xffff0000;
		t= RGB(M0); l|= t&0xffff; m|= t>>16;
		ip[wx+i+Q1]= m; ip[i+Q1] = l;
		}
		if(j&1)cb+= hcs;
		ip+= wix;
		yp+= hcs;
	}
}
/*
**	3x3 RGB dither 3x3 enlaged
*/
#define T(M) (r[y+M-O]|g[y+M+O]|b[y+M-O])
#ifdef LE
#define O0 0
#define O1 1
#define O2 2
#else
#define O0 2
#define O1 1
#define O2 0
#endif
void
disp03(Uc *sif)
{
	Us *cb,*cb0;
	Ui *ip;
	int	i,j,wx,wx2,brd= xys>>3;
#ifdef Long64
	Ul	*r,*g,*b,t;
#else
	Ui	*r,*g,*b,t,t2;
#endif
	Ui	*yp,d,l,m,n;
	Ui	uu,vv;
	Uc	y,u,v;

	wx=  wix>>2;
	wx2= wix>>1;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb0= (Us *)yp+(xys>>1);
	for(j=0;j<winh/3;j++){
		yp= (Ui *)(sif+j*dx);
		ip= (Ui *)(dd+3*j*wix);
		cb= cb0+(j>>1)*(dx>>2);
	for(i=0;i<winw>>2;i+=3,ip+=3){
		vv= *(cb+brd); uu= *cb++;
		u= uu; v= vv;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		m= t>>24; n= t>>40;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		d= *yp++; y= d; t= RGB(0); l= t;
		t= T(768*3); m= t<<8 | l>>24; n= t>>8;
#endif
		l&= 0xffffff; m&= 0xffffff;
		y= d>>8; t= RGB(0);
		*(ip+O0) = t<<24 | l;
		*(ip+wx+O0)= (      t&0xff000000) | m;
#ifdef Long64
		*(ip+wx2+O0)= ((t>>16)&0xff000000) | n;
		l= t>>8; m= t>>32; n= t>>48;
#else
		l= t>>8; t= T(768*3);
		*(ip+wx2+O0)= ((t&0xff00)<<16) | n;
		m= t; n= t>>16;
#endif
		l&=0xffff; m&= 0xffff;

		u= uu>>8; v= vv>>8;
#ifdef Long64
		r= (Ul *)(&Q)+256+(v<<1);
		g= (Ul *)(&Q)+1024-u-v;
		b= (Ul *)(&Q)+(1024+768)+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		*(ip+wx +O1)= ((t>> 8)&0xffff0000) | m;
		*(ip+wx2+O1)= ((t>>24)&0xffff0000) | n;
		m= t>>40; l= t>>16; n= t>>56;
#else
		r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
		y= d>>16; t= RGB(0);
		*(ip+O1)= (t&0xffff)<<16 | l;
		t2= T(768*3);
		*(ip+wx +O1)= t2<<24 | ((t>>8)&0xff0000) | m;
		*(ip+wx2+O1)= ((t2<<8)&0xffff0000) | n;
		l= t>>16; m= t2>>8; n= t2>>24;
#endif
		l&=255; m&=255;
		y= d>>24; t= RGB(0);
		*(ip+O2)= t<<8 | l;
#ifdef Long64
		*(ip+wx +O2)= ((t>>16)&0xffffff00) | m;
		*(ip+wx2+O2)= ((t>>32)&0xffffff00) | n;
#else
		t2= T(768*3);
		*(ip+wx +O2)= (t2&0xffff)<<16 | ((t>>16)&0xff00) | m;
		*(ip+wx2+O2)= (t2&0xffffff00) | n;
#endif
	}}
}

void
disp3z(Uc *sif)
{
	Uc	*cb,*cr;
	Us	*yp;
	Ui	*ip;
	int	i,j,hcs,wx,wy,wy1,wy2,wx1,wx2;
	int	u,v,d,l,m;
	Uc	y;
	Ui	*r,*g,*b,t=0;
	int	sx,sy;
	int	x,iy;

	d= l= m= 0;
	r= g= b= NULL;

	wx= wix; wy= wiy;
	hcs= dx>>1;
	wx1= wx>>1; wx2= wx>>2;
	wy1= wy>>1; wy2= wy>>2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys; cr= cb+(xys>>2);

	sy= iy= 0;
	for(j=0;j<wy;){
		if(sy>=0){ sy-= wy1;
			yp= (Us *)(sif+iy*dx);
			cb= sif+xys+hcs*(iy>>1); cr= cb+(xys>>2);
			ip= (Ui *)(dd+j*wx);
			sx= x= 0;
			for(i=0;i<wx1;){
				if(sx>=0){ sx-= wx1; /* get uv,y */
					if((x++&1)==0){
						int x1= x>>1;
						u= cb[x1]; v= cr[x1];
				r= Q.r+(v<<1); g= Q.g-u-v; b= Q.b+(u<<1);
						d= yp[x1]; y= d;
					}
					else y= d>>8;
					t= RGB(0);
				} else { sx+= dx; /* save colorm */
					if(i++&1){
						l|= t<<16; m|= t&0xffff0000;
						*(ip+wx2)= m; *ip++ = l;
					} else {
						l= t&0xffff; m= t>>16;
					}
				}
			}
			iy++;
		} else {
			sy+= ddy; j+= 2;
			while(sy<0 && j<wy){
				ip= (Ui *)(dd+j*wx);
				for(i=0;i<wx1;i++) ip[i]= ip[i-wx1];
				sy+= ddy; j+= 2;
			}
		}
	}
}

/*
**	disp9.c
**	Full color
*/

#ifdef LE	/* Little-Endian Client */
#define	P0	0
#define	P1	8
#define	P2	16
#define	P3	24
#define C0	0
#define C8	8
#else		/* Big-Endian Client */
#define	P0	24
#define	P1	16
#define	P2	8
#define	P3	0
#define C0	8
#define C8	0
#endif

/*
**	Y,Cb,Cr to r,g,b, pointers
**	those are pointed by y and shifted by (u,v)
**
*/
/*
(1)	simplist
#define rgb(u,v) r= Q.r+(v<<1);g= Q.g-u-v;b= Q.b+(u<<1)
(2)	next 
#define rgb(u,v) {int a= v+(v>>1);\
		int c= u+(u>>1);\
		r= Q.r+a;\
		g= Q.g-(a>>1)-(c>>2);\
		b= Q.b+c;}
	
(3)	from Y,Cb,Cr to r, g, b
#define rgb(u,v) { r= Q.r+(v*359)/256;\
		   g= Q.g-(u*88+v*182)/256;\
		   b= Q.b+(u*454)/256; }

   3590*219/224= 3509
   4540*219/224= 4438
    880*219/224=  860
   1820*219/224= 1779

(4)	almost perfect
#define rgb(u,v) { r= Q.r + v*351/256; \
		   g= Q.g -(u*86+v*178)/256; \
		   b= Q.b + u*443/256; }
(5) simplified
#define rgb(u,v) {r=Q.r+v*11/8;g=Q.g-u*11/32-v*11/16;b=Q.b+u*55/32;}
#define rgb(u,v) {r=Q.r+v*11/8;g=Q.g-(u*5+v*11)/16;b=Q.b+u*55/32;}
#define rgb(u,v) {r=Q.r+v*11/8;g=Q.g-(u*5+v*11)/16;b=Q.b+u*55/32;}
#define rgb(u,v) {r=Q.r+((v*11)>>3);g=Q.g-((u*5+(v*11))>>4);b=Q.b+((u*55)>>5);}
#define rgb(u,v) {v*=11;u*=5;r=Q.r+(v>>3);g=Q.g-((u+v)>>4);b=Q.b+((u*11)>>5);}

Simpified YUV to RGB (by Fukutome)
This was moved to this file 2001 7/6 from memo.
y= (Y-16)*9;
u= U-128;
v= V-128;
R= (y + v*13)>>3;
B= (y + u*16)>>3;
G= (Y*7-R*2-B)>>2;

*/
#define rgb(u,v) {v*=11;u*=5;r=Q.r+(v>>3);g=Q.g-((u+v)>>4);b=Q.b+((u*11)>>5);}

extern Visual *vis;
extern int dep;


/*
**	True color display using XPutPixel()
*/
void
disp90(Uc *sif)
{
	Us *cb,*cr;
	Ui *sp,*yp;
	int	i,j,hcs,wx,wy;

	hcs= dx>>2;
	wx= winw;
	wy= winh;
	sp= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+xys);
	cr= (Us *)(sif+xys+(xys>>2));
	for(j=0;j<wy;j+=2){
	for(i=0;i<wx;i+=4){
		int	y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,t;

		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+0,j+0,t);
		y= (Uc)(h>>P1); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+1,j+0,t);
		y= (Uc)(l>>P0); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+0,j+1,t);
		y= (Uc)(l>>P1); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+1,j+1,t);

		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+2,j+0,t);
		y= (Uc)(h>>P3); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+3,j+0,t);
		y= (Uc)(l>>P2); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+2,j+1,t);
		y= (Uc)(l>>P3); t= r[y]|g[y]|b[y];
		XPutPixel(xi,i+3,j+1,t);
		}
		yp+= hcs; sp+= wx>>2;
	}
}

/*
**	256 True colors
*/
void
disp91(Uc *sif, int t)
{
	Us *cb,*cr;
	Ui *sp,*yp;
	int	i,j,hcs,wx,wy;

	hcs= dx>>2;
	wx= winw>>2;
	wy= winh>>1;
	sp= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+xys);
	cr= (Us *)(sif+xys+(xys>>2));

	for(j=0;j<wy;j++){
	for(i=0;i<wx;i++){
		int	y,u,v;
		Ui cbd,crd,*r,*g,*b,h,l,a,c;

		cbd= *cb++; crd= *cr++;
		u= (Uc)(cbd>>C0)-128; v= (Uc)(crd>>C0)-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>P0); a = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(h>>P1); a|= (r[y]|g[y]|b[y])<<P1;
		y= (Uc)(l>>P0); c = (r[y]|g[y]|b[y])<<P0;
		y= (Uc)(l>>P1); c|= (r[y]|g[y]|b[y])<<P1;

		u= (Uc)(cbd>>C8)-128; v= (Uc)(crd>>C8)-128;
		rgb(u,v);
		y= (Uc)(h>>P2); a|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(h>>P3); a|= (r[y]|g[y]|b[y])<<P3;
		y= (Uc)(l>>P2); c|= (r[y]|g[y]|b[y])<<P2;
		y= (Uc)(l>>P3); c|= (r[y]|g[y]|b[y])<<P3;
		*(sp+wx)= c;
		*sp++= a;
		}
		yp+= hcs; sp+= wx;
	}
}

/*
**	True Color (2 byte pixel)
*/
void
disp921(Uc *sif,int t,int brd)
{
	Uc *cb; Us *yp; Ui *ip;
	int i,j,hcs;

	int  wx= xi->bytes_per_line/4;
	if(t)wx= dx*(xi->bits_per_pixel/8)/4;

	hcs= dx>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<winh>>1;j++){
	for(i=0;i<winw>>1;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l,a,c;
		u= cb[i]-128; v= cb[brd+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
		y= (Uc)(l>>C0); a = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(l>>C8); a|= (r[y]|g[y]|b[y])<<C8*2;
		ip[wx+i]= a;
		y= (Uc)(h>>C0); c = (r[y]|g[y]|b[y])<<C0*2;
		y= (Uc)(h>>C8); c|= (r[y]|g[y]|b[y])<<C8*2;
		ip[i] = c;
		}
		yp+= dx; ip+= wx*2;
		cb+= hcs;
	}
}

void
disp922(Uc *sif,int brd)
{
	Us *cb; Ui *yp; Ui *ip;
	int i,j,hcs,wx,wx2,wx3;

	brd/= 2;
	hcs= dx>>2;
	wx=  wix/2;
	wx2= wix;
	wx3= wx+wx2;
	ip= (Ui *)dd;
	yp= (Ui *)sif;
	cb= (Us *)(sif+xys);

	for(j=0;j<wiy;j+=4){
	for(i=0;i<wx/4;i++){
		Us	uu,vv;
		int	y,u,v;
		Ui *r,*g,*b,a;
		Ui l,h;
		vv= cb[brd+i]; uu= cb[i];
		v= (Uc)(vv>>C8) -128; u= (Uc)(uu>>C8) -128;
		rgb(u,v);
		l= yp[hcs+i];
		h= yp[i];
		y= (Uc)(l>>P3); a= r[y]|g[y]|b[y];
		ip[wx3+3]= ip[wx2+3]= a;
		y= (Uc)(h>>P3); a= r[y]|g[y]|b[y];
		ip[wx+3]= ip[3]= a;

		y= (Uc)(l>>P2); a= r[y]|g[y]|b[y];
		ip[wx3+2]= ip[wx2+2]= a;
		y= (Uc)(h>>P2); a= r[y]|g[y]|b[y];
		ip[wx+2]= ip[2]= a;

		v= (Uc)(vv>>C0) -128; u= (Uc)(uu>>C0) -128;
		rgb(u,v);
		y= (Uc)(l>>P1); a= r[y]|g[y]|b[y];
		ip[wx3+1]= ip[wx2+1]= a;
		y= (Uc)(h>>P1); a= r[y]|g[y]|b[y];
		ip[wx+1]= ip[1] = a;

		y= (Uc)(l>>P0); a= r[y]|g[y]|b[y];
		ip[wx3]=   ip[wx2]=   a;
		y= (Uc)(h>>P0); a= r[y]|g[y]|b[y];
		ip[wx]= ip[0] = a;
		ip+= 4;
		}
		yp+= dx>>1; ip+= wx*3; cb+= hcs;
	}
}
/*
disp922(sif,brd)
Uc	*sif;
	{
	Uc *cb; Us *yp; Ui *ip;
	int i,j,hcs,wx,wx2,wx3;

	hcs= dx>>1;
	wx=  wix/2;
	wx2= wix;
	wx3= wx+wx2;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<wiy;j+=4){
	for(i=0;i<wx/2;i++){
		int	y,u,v;
		Ui *r,*g,*b,a;
		Us d;
		v= cb[brd+i]-128; u= cb[i]-128;
		rgb(u,v);
		d= yp[hcs+i];
		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx3+1]= ip[wx2+1]= a|a<<16;
		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		ip[wx3]=   ip[wx2]=   a|a<<16;
		d= yp[i];
		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx+1]= ip[1]= a|a<<16;
		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		ip[wx]= ip[0] = a|a<<16;
		ip+= 2;
		}
		yp+= dx; ip+= wx*3; cb+= hcs;
		}
	}
*/

void
disp923(Uc *sif,int brd)
{
	Uc *cb; Us *yp; Ui *ip,*ip0;
	int i,j,hcs,wx,wx2,wx3,wx4,wx5;

	hcs= dx>>1;
	wx=  wix/2;
	wx2= wix;
	wx3= wx+wx2;
	wx4= wx2*2;
	wx5= wx4+wx;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<wiy;j+=6){
		ip0= ip;
	for(i=0;i<wx/3;i++){
		int	y,u,v;
		Ui *r,*g,*b,a,a1;
		Us d;
		v= cb[brd+i]-128; u= cb[i]-128;
		rgb(u,v);
		d= yp[hcs+i];

		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx5+2]= ip[wx4+2]= ip[wx3+2]= a|a<<16;

		y= (Uc)(d>>C0); a1= r[y]|g[y]|b[y];
		ip[wx5]= ip[wx4]=   ip[wx3]=   a1|a1<<16;

		ip[wx5+1]= ip[wx4+1]= ip[wx3+1]= a<<16|a1;

		d= yp[i];
		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx2+2]= ip[wx+2]= ip[2]= a|a<<16;

		y= (Uc)(d>>C0); a1= r[y]|g[y]|b[y];
		ip[wx2]= ip[wx]= ip[0] = a1|a1<<16;

		ip[wx2+1]= ip[wx+1]= ip[1]= a<<16|a1;

		ip+= 3;
		}
		yp+= dx; ip= ip0 + wx*6; cb+= hcs;
	}
}

void
disp924(Uc *sif,int brd)
	{
	Uc *cb; Us *yp; Ui *ip;
	int i,j,hcs,wx,wx2,wx3,wx4,wx5,wx6,wx7;

	hcs= dx>>1;
	wx=  wix/2; wx2= wix; wx3= wx*3; wx4= wx*4; wx5= wx*5; wx6= wx*6; wx7= wx*7;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<wiy;j+=8){
	for(i=0;i<wx/4;i++){
		int	y,u,v;
		Ui *r,*g,*b,a;
		Us d;
		v= cb[brd+i]-128; u= cb[i]-128;
		rgb(u,v);
		d= yp[hcs+i];

		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx7+2]= ip[wx7+3]= ip[wx6+2]= ip[wx6+3]=
		ip[wx5+2]= ip[wx5+3]= ip[wx4+2]= ip[wx4+3]= a|a<<16;

		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		ip[wx7]= ip[wx7+1]= ip[wx6]= ip[wx6+1]=
		ip[wx5]= ip[wx5+1]= ip[wx4]= ip[wx4+1]= a|a<<16;

		d= yp[i];
		y= (Uc)(d>>C8); a= r[y]|g[y]|b[y];
		ip[wx3+2]= ip[wx3+3]= ip[wx2+2]= ip[wx2+3]=
		ip[wx +2]= ip[wx +3]= ip[    2]= ip[    3]= a|a<<16;

		y= (Uc)(d>>C0); a= r[y]|g[y]|b[y];
		ip[wx3]= ip[wx3+1]= ip[wx2]= ip[wx2+1]=
		ip[wx ]= ip[wx +1]= ip[  0]= ip[    1]= a|a<<16;

		ip+= 4;
		}
		yp+= dx; ip+= wx*7; cb+= hcs;
	}
}
	
/*
**	True Color (3 byte pixel)
*/
void
disp931(Uc *sif,int t,int brd)
{
	Uc *cb; Us *yp; Ui *ip;
	int i,j,hcs,wx= xi->bytes_per_line/4;
	if(t)wx= dx*(xi->bits_per_pixel/8)/4;

	hcs= dx>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;
	for(j=0;j<(winh>>1);j++){
	for(i=0;i<(winw>>2);i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l,t1,t2,m1,m2;

		v= cb[brd]-128; u= *cb++-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); t2= r[y]|g[y]|b[y];
		ip[0]= t1|t2<<24;
		m1= t2;
		y= (Uc)(l>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); t2= r[y]|g[y]|b[y];
		ip[wx]= t1|t2<<24;
		m2= t2;
		v= cb[brd]-128; u= *cb++-128;
		rgb(u,v);
		l= *(yp+hcs); h= *yp++;
		y= (Uc)(h>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); t2= r[y]|g[y]|b[y];
		ip[1]= m1>>8|t1<<16;
		ip[2]= t1>>16|t2<<8;
		y= (Uc)(l>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); t2= r[y]|g[y]|b[y];
		ip[wx+1]= m2>>8|t1<<16;
		ip[wx+2]= t1>>16|t2<<8;
		ip+=3;
		}
		yp+= hcs; ip+= wx;
	}
}

void
disp932(Uc *sif,int brd)
{
	Uc *cb;
	Us *yp;
	Ui *ip,*ip0;
	int i,j,hcs,wx= xi->bytes_per_line>>2;
	int wx2,wx3;

	wx2= wx*2;
	wx3= wx*3;
	hcs= dx>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<(winh>>2);j++){
		ip0= ip;
	for(i=0;i<(winw>>2);i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l,t1,t2;

		u= cb[i]-128; v= cb[i+brd]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
		y= (Uc)(h>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); t2= r[y]|g[y]|b[y];

		ip[wx]=   ip[0]= t1|t1<<24; 	/* brgb */
		ip[wx+1]= ip[1]= t1>>8|t2<<16;	/* GBrg */
		ip[wx+2]= ip[2]= t2<<8|t2>>16;	/* RGBR */

		y= (Uc)(l>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); t2= r[y]|g[y]|b[y];

		ip[wx3]=   ip[wx2]=   t1|t1<<24;
		ip[wx3+1]= ip[wx2+1]= t1>>8|t2<<16;
		ip[wx3+2]= ip[wx2+2]= t2<<8|t2>>16;

		ip+= 3;
		}
		yp+= dx; ip= ip0+ wx*4; cb+= hcs;
	}
}

void
disp933(Uc *sif,int brd)
{
	Uc *cb;
	Us *yp;
	Ui *ip,*ip0;
	int i,j,hcs,wx= xi->bytes_per_line>>2;
	int wx2,wx3,wx4,wx5;
	Ui tm1;
	Ui tm2;
	wx2= wx*2;
	wx3= wx*3;
	wx4= wx*4;
	wx5= wx*5;
	hcs= dx>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<(winh/6);j++){
		ip0= ip;
	for(i=0;i<(winw/6);i+=2){
		int	y,u,v;
		Ui *r,*g,*b,h,l,t1,t2;

		u= cb[i]-128; v= cb[i+brd]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
		y= (Uc)(h>>C0); t1= r[y]|g[y]|b[y];	/* left pix */
		y= (Uc)(h>>C8); t2= r[y]|g[y]|b[y];	/* right pix */

		ip[wx2  ]= ip[wx  ]= ip[0]= t1|t1<<24; 	 /* b rgb */
		ip[wx2+1]= ip[wx+1]= ip[1]= t1>>8|t1<<16;/* gb rg */
		ip[wx2+2]= ip[wx+2]= ip[2]= t2<<8|t1>>16;/* RGB r */
		ip[wx2+3]= ip[wx+3]= ip[3]= t2<<24|t2;	 /* B RGB */
		tm1= t2;/* save */
		y= (Uc)(l>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); t2= r[y]|g[y]|b[y];
		ip[wx5  ]= ip[wx4  ]= ip[wx3  ]= t1|t1<<24; 	/* b rgb */
		ip[wx5+1]= ip[wx4+1]= ip[wx3+1]= t1>>8|t1<<16;	/* gb rg */
		ip[wx5+2]= ip[wx4+2]= ip[wx3+2]= t2<<8|t1>>16;	/* RGB r */
		ip[wx5+3]= ip[wx4+3]= ip[wx3+3]= t2<<24|t2;	/* B RGB */
		tm2= t2;			/* save */

		u= cb[i+1]-128; v= cb[i+1+brd]-128;
		rgb(u,v);
		l= yp[hcs+i+1]; h= yp[i+1];
		y= (Uc)(h>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); t2= r[y]|g[y]|b[y];
		ip[wx2+4]= ip[wx+4]= ip[4]= tm1>>8|t1<<16;	/* gb RG */
		ip[wx2+5]= ip[wx+5]= ip[5]= t1<<8|t1>>16;	/* rgb r */
		ip[wx2+6]= ip[wx+6]= ip[6]= t1|t2<<24;	/* B rgb */
		ip[wx2+7]= ip[wx+7]= ip[7]= t2>>8|t2<<16;	/* GB RG */
		ip[wx2+8]= ip[wx+8]= ip[8]= t2>>16|t2<<8;	/* RGB R */
		y= (Uc)(l>>C0); t1= r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); t2= r[y]|g[y]|b[y];
		ip[wx5+4]= ip[wx4+4]= ip[wx3+4]= tm2>>8|t1<<16;	/* gb RG */
		ip[wx5+5]= ip[wx4+5]= ip[wx3+5]= t1<<8|t1>>16;	/* rgb r */
		ip[wx5+6]= ip[wx4+6]= ip[wx3+6]= t1|t2<<24;	/* B rgb */
		ip[wx5+7]= ip[wx4+7]= ip[wx3+7]= t2>>8|t2<<16;	/* GB RG */
		ip[wx5+8]= ip[wx4+8]= ip[wx3+8]= t2>>16|t2<<8;	/* RGB R */
		ip+=9;
		}
		yp+= dx; ip= ip0+ wx*6; cb+= hcs;
	}
}

/*
**	True Color (4 byte pixel)
*/
void
disp941(Uc *sif,int t,int brd)
{
	Uc *cb;
	Us *yp;
	Ui *ip,*ip0;
	int	i,j,hcs;
	int wx= xi->bytes_per_line/4;
	if(t) wx= dx*(xi->bits_per_pixel/8)/4;

	hcs= dx>>1;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;

	for(j=0;j<winh>>1;j++){
		ip0= ip;
	for(i=0;i<winw>>1;i++){
		int	y,u,v;
		Ui *r,*g,*b,h,l;
		u= cb[i]-128; v= cb[brd+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
		y= (Uc)(h>>C0); ip[0]=    r[y]|g[y]|b[y];
		y= (Uc)(h>>C8); ip[1]=    r[y]|g[y]|b[y];
		y= (Uc)(l>>C0); ip[wx]=   r[y]|g[y]|b[y];
		y= (Uc)(l>>C8); ip[wx+1]= r[y]|g[y]|b[y];
		ip+=2;
		}
		yp+= dx; cb+= hcs; ip= ip0+wx*2;
	}
}

void
disp942(Uc *sif,int brd)
{	 
	Uc *cb;
	Us *yp;   
	Ui *ip,*ip0;   
	int     i,j,hcs,wx,wx2,wx3;

	hcs= dx>>1;
	//wx= winw;						   
	wx= wix;						   
	wx2= wx*2;
	wx3= wx*3;
	ip= (Ui *)dd;
	yp= (Us *)sif;
	cb= sif+xys;
	for(j=0;j<(winh>>2);j++){
//#define XYFIL		// horizontal and vertical interpolation (use with XFIL)
//#define XFIL		// horizontal linear interpolation
#ifdef XFIL
		int a=0, c=0,z;	// a:upper horizontal last luma, c: lower horizontal last luma.
#endif
		ip0= ip;
	for(i=0;i<(winw>>2);i++){
		int y,u,v;
#ifdef XFIL
		int w,x;
#endif
		Ui *r,*g,*b,h,l;
		u= cb[i]-128; v= cb[brd+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];
#ifdef XYFIL
	// make left side 2x4 pels
	if(j){ y= (Uc)(yp[i-hcs]>>C0); w= (c+y)>>1; } else y= w= 0;				// get the last line 
	x= (Uc)(h>>C0); z= (a+x)>>1; a= x; ip[wx]= r[z]|g[z]|b[z]; ip[wx+1]= r[x]|g[x]|b[x];	// new line 1
	z= (z+w)>>1; ip[0]= r[z]|g[z]|b[z]; y= (x+y)>>1; ip[1]= r[y]|g[y]|b[y]; // interpolate vertical w last line
	y= (Uc)(l>>C0); w= (c+y)>>1; c= y; ip[wx3  ]= r[w]|g[w]|b[w]; ip[wx3+1]= r[y]|g[y]|b[y];// new line 2
	z= (z+w)>>1; ip[wx2  ]= r[z]|g[z]|b[z]; y= (x+y)>>1; ip[wx2+1]= r[y]|g[y]|b[y]; // interpolate w newline 1

	// make right side 2x4 pels
	if(j){ y= (Uc)(yp[i-hcs]>>C8); w= (c+y)>>1; } else y= w= 0;
	x= (Uc)(h>>C8); z= (a+x)>>1; a= x; ip[wx+2]= r[z]|g[z]|b[z]; ip[wx+3]= r[x]|g[x]|b[x];
	z= (z+w)>>1; ip[2]= r[z]|g[z]|b[z]; y= (x+y)>>1; ip[3]= r[y]|g[y]|b[y]; 
	y= (Uc)(l>>C8); w= (c+y)>>1; c= y; ip[wx3+2]= r[w]|g[w]|b[w]; ip[wx3+3]= r[y]|g[y]|b[y];
	z= (z+w)>>1; ip[wx2+2]= r[z]|g[z]|b[z]; y= (x+y)>>1; ip[wx2+3]= r[y]|g[y]|b[y]; 
#else
#ifdef XFIL
	y= (Uc)(h>>C0); z= (a+y)>>1; ip[wx   ]= ip[    0]= r[z]|g[z]|b[z]; ip[wx +1]= ip[    1]= r[y]|g[y]|b[y]; a= y;
	y= (Uc)(h>>C8); z= (a+y)>>1; ip[wx+2 ]= ip[    2]= r[z]|g[z]|b[z]; ip[wx +3]= ip[    3]= r[y]|g[y]|b[y]; a= y;
	y= (Uc)(l>>C0); z= (c+y)>>1; ip[wx3  ]= ip[wx2  ]= r[z]|g[z]|b[z]; ip[wx3+1]= ip[wx2+1]= r[y]|g[y]|b[y]; c= y;
	y= (Uc)(l>>C8); z= (c+y)>>1; ip[wx3+2]= ip[wx2+2]= r[z]|g[z]|b[z]; ip[wx3+3]= ip[wx2+3]= r[y]|g[y]|b[y]; c= y;
#else
	y= (Uc)(h>>C0);ip[wx  ]= ip[wx+1]= ip[0]= ip[1]= r[y]|g[y]|b[y];
	y= (Uc)(h>>C8);ip[wx+2]= ip[wx+3]= ip[2]= ip[3]= r[y]|g[y]|b[y];
	y= (Uc)(l>>C0);ip[wx3 ]= ip[wx3+1]=ip[wx2  ]=ip[wx2+1]= r[y]|g[y]|b[y];
	y= (Uc)(l>>C8);ip[wx3+2]=ip[wx3+3]=ip[wx2+2]=ip[wx2+3]= r[y]|g[y]|b[y];
#endif
#endif
		ip+=4;
		}
		yp+= dx; ip= ip0+wx*4;
		cb+= hcs;
	}
}

void
disp943(Uc *sif,int brd)
{	 
	Uc *cb; Us *yp;   
	Ui *ip,*ip0;   
	int     i,j,hcs,wx,wx2,wx3,wx4,wx5;
	hcs= dx>>1; wx= wix;						   
	wx2= wx*2; wx3= wx*3; wx4= wx*4; wx5= wx*5;
	ip= (Ui *)dd; yp= (Us *)sif; cb= sif+xys;

	for(j=0;j<(winh/6);j++){
		ip0= ip;
	for(i=0;i<(winw/6);i++){
		int     y,u,v;
		Ui *r,*g,*b,h,l;
		u= cb[i]-128; v= cb[brd+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];

		y= (Uc)(h>>C0);
		ip[wx2]= ip[wx2+1]= ip[wx2+2]= 
		ip[wx ]= ip[wx +1]= ip[wx +2]=
		ip[0]= ip[1]= ip[2]= r[y]|g[y]|b[y];

		y= (Uc)(h>>C8);
		ip[wx2+3]= ip[wx2+4]= ip[wx2+5]=
		ip[wx +3]= ip[wx +4]= ip[wx +5]=
		ip[3]= ip[4]= ip[5]= r[y]|g[y]|b[y];

		y= (Uc)(l>>C0);
		ip[wx5]= ip[wx5+1]= ip[wx5+2]=
		ip[wx4]= ip[wx4+1]= ip[wx4+2]=
		ip[wx3]= ip[wx3+1]= ip[wx3+2]= r[y]|g[y]|b[y];

		y= (Uc)(l>>C8); 
		ip[wx5+3]= ip[wx5+4]= ip[wx5+5]=
		ip[wx4+3]= ip[wx4+4]= ip[wx4+5]=
		ip[wx3+3]= ip[wx3+4]= ip[wx3+5]= r[y]|g[y]|b[y];
		ip+=6;
		}
		yp+= dx; ip= ip0+wx*6;
		cb+= hcs;
	}
}

void
disp944(Uc *sif,int brd)
{	 
	Uc *cb; Us *yp;   
	Ui *ip,*ip0;   
	int     i,j,hcs,wx,wx2,wx3,wx4,wx5,wx6,wx7;
	hcs= dx>>1; wx= wix;						   
	wx2= wx*2; wx3= wx*3; wx4= wx*4; wx5= wx*5; wx6= wx*6; wx7= wx*7;
	ip= (Ui *)dd; yp= (Us *)sif; cb= sif+xys;

	for(j=0;j<(winh/8);j++){ ip0= ip;
	for(i=0;i<(winw/8);i++){
		int     y,u,v;
		Ui *r,*g,*b,h,l;
		u= cb[i]-128; v= cb[brd+i]-128;
		rgb(u,v);
		l= yp[hcs+i]; h= yp[i];

		y= (Uc)(h>>C0);
		ip[wx3]= ip[wx3+1]= ip[wx3+2]= ip[wx3+3]= 
		ip[wx2]= ip[wx2+1]= ip[wx2+2]= ip[wx2+3]= 
		ip[wx ]= ip[wx +1]= ip[wx +2]= ip[wx +3]=
		ip[  0]= ip[    1]= ip[    2]= ip[    3]= r[y]|g[y]|b[y];

		y= (Uc)(h>>C8);
		ip[wx3+4]= ip[wx3+5]= ip[wx3+6]= ip[wx3+7]= 
		ip[wx2+4]= ip[wx2+5]= ip[wx2+6]= ip[wx2+7]= 
		ip[wx +4]= ip[wx +5]= ip[wx +6]= ip[wx +7]=
		ip[    4]= ip[    5]= ip[    6]= ip[    7]= r[y]|g[y]|b[y];

		y= (Uc)(l>>C0);
		ip[wx7]= ip[wx7+1]= ip[wx7+2]= ip[wx7+3]=
		ip[wx6]= ip[wx6+1]= ip[wx6+2]= ip[wx6+3]=
		ip[wx5]= ip[wx5+1]= ip[wx5+2]= ip[wx5+3]=
		ip[wx4]= ip[wx4+1]= ip[wx4+2]= ip[wx4+3]= r[y]|g[y]|b[y];

		y= (Uc)(l>>C8); 
		ip[wx7+4]= ip[wx7+5]= ip[wx7+6]= ip[wx7+7]=
		ip[wx6+4]= ip[wx6+5]= ip[wx6+6]= ip[wx6+7]=
		ip[wx5+4]= ip[wx5+5]= ip[wx5+6]= ip[wx5+7]=
		ip[wx4+4]= ip[wx4+5]= ip[wx4+6]= ip[wx4+7]= r[y]|g[y]|b[y];
		ip+=8;
		}
		yp+= dx; ip= ip0+wx*8; cb+= hcs;
	}
}

void
disp(int ddt, Uc *sif, int t, int x2)
{
	int brd= xys/4;
        int boex= (ImageByteOrder(dpy)==
#ifdef LE
        MSBFirst
#else
        LSBFirst
#endif
        );
	if(ddt==9) {
		if(dep>=16){
		if(xi->bits_per_pixel==32) {
			if(x2==4) disp944(sif,brd);
			else if(x2==3) disp943(sif,brd);
			else if(x2==2) disp942(sif,brd);
			else disp941(sif,t,brd);
		}
		else if(xi->bits_per_pixel==24) {
			/*if(x2==4) disp934(sif,brd);
			else */if(x2==3) disp933(sif,brd);
			else if(x2==2) disp932(sif,brd);
			else disp931(sif,t,brd);
		}
		else if(dep<=16) {
			if(x2==4) disp924(sif,brd);
			else if(x2==3) disp923(sif,brd);
			else if(x2==2) disp922(sif,brd);
			else disp921(sif,t,brd);
		}
		} else if(dep<=8)disp91(sif,t);
		else if(boex) disp90(sif);
	} else if(ddt==0){
		     if(x2==0) disp3z(sif);
		else if(x2==1) disp01(sif);
		else if(x2==2) disp02(sif);
		else if(x2==3) disp03(sif);
		else if(x2==4) disp04(sif);
	}
}
void
disp9(sif,t)
Uc      *sif;
        {
        int brd= xys/4;
        int boex= (ImageByteOrder(dpy)==
#ifdef LE
        MSBFirst
#else
        LSBFirst
#endif
        );
	if(dep<=8)disp91(sif,t);
	else if(boex) disp90(sif);
	else if(dep<=16){
		if(x2==3) disp923(sif,brd);
		else if(x2==2) disp922(sif,brd);
		else disp921(sif,t,brd);
	}
	else if(xi->bits_per_pixel==24) {
		if(x2==3) disp933(sif,brd);
		else if(x2==2) disp932(sif,brd);
		else    disp931(sif,t,brd);
	} else {
		if(x2==3) disp943(sif,brd);
		else if(x2==2) disp942(sif,brd);
			else  disp941(sif,t,brd);
	}
}

