/*
**
**
**	exp.c
**
**
*/
#include "mpeg.h"
#include "disp.h"

void
expand(Uc *p1,Ui *q,int wx,int wy,int lbp,Ui *z)
{
	int i,j,sx,sy,x,y;
	int bpp= xi->bits_per_pixel;
	int w= xi->bytes_per_line/4;

	if(x2==1){
		Ui *p= (Ui *)p1;
		int len= ((wix*wy)<<lbp)/sizeof(Ui);
		for(j=0;j<len;j+=4){
			q[j  ]= p[j  ]; q[j+1]=p[j+1];
			q[j+2]= p[j+2]; q[j+3]=p[j+3];
		}
	}
	else if(x2==2){
		for(j=0;j<wy;j+=2){ 
			if(lbp==0){
				Us *p= (Us *)p1;
				for(i=0;i<(dx>>1);i++){
					Ui d= p[i];
					d= (d&(255<<8))<<8 | (d&255);
					q[i+w]= q[i]= d|d<<8;
				}
			}
			else if(lbp==1) {
				Us *p= (Us *)p1;
				for(i=0;i<dx;i++){
					Ui d= p[i];
					q[i+w]= q[i]= d|d<<16;
				}
			}
			else if(bpp==24){
				Uc *r= (Uc *)q;
				for(i=0;i<dx*3;r+=6){
					r[3]= r[0]= p1[i++];
					r[4]= r[1]= p1[i++];
					r[5]= r[2]= p1[i++];
				}
				for(i=0;i<w;i+=4){
					q[i+w]=   q[i];
					q[i+w+1]= q[i+1];
					q[i+w+2]= q[i+2];
					q[i+w+3]= q[i+3];
				}
			}
			else if(lbp==2) {
				Ui *p= (Ui *)p1;
				for(i=0;i<dx;i++)
				 q[2*i+w+1]= q[2*i+w]= q[2*i+1]= q[2*i]= p[i];
			}
			p1+= w*2;
			q+=  w*2;
		}
	}
		
	else if(x2==3){
		Ui *p= (Ui *)p1;
		int ix= (dx>>2)<<lbp;
		for(j=0;j<ddy;j++){ 
			int k;
			if(lbp==0) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				Uc d0= d; Uc d1= d>>8;
				Uc d2= d>>16; Uc d3= d>>24;
#ifdef LE
				q[i  ]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i+2]= d3*(((1<<16)+257)<<8) | d2;
#else
				q[i+2]= d1<<24 | d0*((1<<16)+257);
				q[i+1]= (d2<<16 | d1)*257;
				q[i  ]= d3*(((1<<16)+257)<<8) | d2;
#endif
			}
			else if(lbp==1) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
#ifdef LE
				Us d0= d;
				Us d1= d>>16;
#else
				Us d1= d;
				Us d0= d>>16;
#endif
				q[i  ]= d0<<16|d0;
				q[i+1]= d1<<16|d0;
				q[i+2]= d1<<16|d1;
			}
			else if(bpp==24){
				Uc *r= (Uc *)q;
				for(i=0;i<dx*3;r+=9){
					r[6]= r[3]= r[0]= p1[i++];
					r[7]= r[4]= r[1]= p1[i++];
					r[8]= r[5]= r[2]= p1[i++];
				}
				p1+= dx*3;
			}
			else if(lbp==2) for(i=k=0;k<ix;k++,i+=3){
				Ui d= *p++;
				q[i+2]= q[i+1]= q[i  ]= d;
			}
			for(k=0;k<w;k+=2){
				q[k+w*2]=q[k+w]=q[k];
				q[k+w*2+1]=q[k+w+1]=q[k+1];
			}
			q+= w*3;
		}
	}
	else if(x2==4){
		Ui *p= (Ui *)p1;
		int ix= dx*(bpp/8);
		for(j=0;j<ddy;j++){ 
			if(lbp==0) for(i=0;i<dx;i++){
				Ui d= p1[i];
				d|= d<<8;
				q[i]= d<<16 | d;
			}
			else if(lbp==1) for(i=0;i<dx;i++){
				Ui d= *((Us *)p1+i);
				q[2*i+1]= q[2*i]= d<<16 | d;
			}
			else if(bpp==24){
				Uc *r= (Uc *)q;
				for(i=0;i<ix;r+=12){
					r[9]= r[6]= r[3]= r[0]= p1[i++];
					r[10]=r[7]= r[4]= r[1]= p1[i++];
					r[11]=r[8]= r[5]= r[2]= p1[i++];
				}
			}
			else if(lbp==2) for(i=0;i<dx;i++){
				q[4*i+3]= q[4*i+2]= q[4*i+1]= q[4*i]= p[i];
			}
			for(i=0;i<w;i+=2){
				q[i+w*3]= q[i+w*2]= q[i+w]= q[i];
				q[i+w*3+1]= q[i+w*2+1]= q[i+w+1]= q[i+1];
			}
			p1+= ix;
			p+= ix/4;
			q+= w*4;
		}
	}
	else if(x2==0){/* variable expansion */
		Ui d=0,d0=0,d1=0,d2=0;
		j= sy= y= 0;
		while(j<wy)
		 if(sy>=0){
			i= sx= x= 0;
			if(lbp==0) while(i<wx) {
				if(sx>=0){ sx-= wx; d= p1[x++]; }
				else { sx+= dx; ((Uc *)z)[i++]= d; }
			}
			else if(lbp==1) while(i<wx) {
				if(sx>=0){ sx-= wx; d= ((Us *)p1)[x++]; }
				else { sx+= dx; ((Us *)z)[i++]= d; }
			}
			else if(bpp==24) while(i<wx*3) {
			 if(sx>=0){ sx-= wx;d0=p1[x++];d1=p1[x++];d2=p1[x++];}
			 else { sx+= dx; ((Uc *)z)[i++]= d0; ((Uc *)z)[i++]= d1;
				((Uc *)z)[i++]= d2; }
			}
			else if(lbp==2) while(i<wx) {
				if(sx>=0){ sx-= wx; d= ((Ui *)p1)[x++]; }
				else { sx+= dx; z[i++]= d; }
			}
			if(bpp==24)p1+= dx*3;
			   else    p1+= dx<<lbp;
			sy-= wy;
		} else {
			for(i=0;i<w;i++) q[i]= z[i];
			q+= w; sy+= ddy; j++;
		}
	}
	else for(j= 0;j<wy;){ /* integer (>4) expanding */
		int k;
		Ui d;
		i= x= 0;
		if(lbp==0)while(i<wx){
			d= p1[x++];
			for(k=0;k<x2;k++) ((Uc *)q)[i++]= d;
		}
		else if(lbp==1)while(i<wx){
			d= ((Us *)p1)[x++];
			for(k=0;k<x2;k++) ((Us *)q)[i++]= d;
		}
		else if(bpp==24)while(i<wx*3){
			int d0,d1,d2;
			d0=p1[x++];d1=p1[x++];d2=p1[x++];
			for(k=0;k<x2;k++){
				((Uc *)q)[i++]= d0;
				((Uc *)q)[i++]= d1;
				((Uc *)q)[i++]= d2;
			}
		}
		else if(lbp==2)while(i<wx){
			d= ((Ui *)p1)[x++];
			for(k=0;k<x2;k++) q[i++]= d;
		}
		if(bpp==24)p1+= dx*3;
		   else    p1+= dx<<lbp;
		j++;
		q+= w;
		for(k=1;k<x2;k++){
			for(i=0;i<w;i++) q[i]= q[i-w];
			q+= w; j++;
		}
	}
}
