/*
**	idct.c
**
*/

#include "mpeg.h"

#define Clip(k) if(k>255){if(k>=(1<<15))k=0;else k=255;}
#define Clip1(k) k-=256;if(k>255){if(k>=(1<<15))k=0;else k=255;}

#ifdef LE
#define S0 0
#define S1 8
#define S2 16
#define S3 24
#else
#define S0 24
#define S1 16
#define S2 8
#define S3 0
#endif

#define Ad 1
#define Bd 8
#define A0 0
#define A1 8
#define A2 16
#define A3 24
#define A4 32
#define A5 40
#define A6 48
#define A7 56
#define B0 0
#define B1 1
#define B2 2
#define B3 3
#define B4 4
#define B5 5
#define B6 6
#define B7 7

void
qdct(int *in,Ul *p0,int intra,Ui cola)
{
double	wk[64];
int	i;
int	*ip;
double	*dp;
register double c0= 0.35355339059327370;
register double c1= 0.49039264020161520;
register double c2= 0.46193976625564330;
register double c3= 0.41573480615127260;
register double c5= 0.27778511650980110;
register double c6= 0.19134171618254490;
register double c7= 0.09754516100806417;

ip= in;
dp= wk;
for(i= 8 ; i-- ;ip+= Ad, dp+= Ad, cola>>=1)if(cola&1){
	int	i0,i1,i2,i3,i4,i5,i6,i7;
	double y,p,t,x,b,d,f,h;

	i0= ip[A0]; i1= ip[A1]; i2= ip[A2]; i3= ip[A3];
	i4= ip[A4]; i5= ip[A5]; i6= ip[A6]; i7= ip[A7];

	y= p= c0*i0; if(i4){ y+= i4*c0; p-= i4*c0; }
	t= c2*i2; x= c6*i2; if(i6){ t+= c6*i6; x-= c2*i6; }
	b=d=f=h=0;
	if(i7){ b+= c7*i7; d+= -c1*i7; f+= -c5*i7; h+=  c3*i7; }
	if(i5){ b+= c5*i5; d+=  c3*i5; f+= -c1*i5; h+=  c7*i5; }
	if(i3){ b+= c3*i3; d+= -c5*i3; f+= -c7*i3; h+= -c1*i3; }
	if(i1){ b+= c1*i1; d+=  c7*i1; f+=  c3*i1; h+=  c5*i1; }
	dp[A0]= y+t+b; dp[A7]= y+t-b;
	dp[A3]= y-t+d; dp[A4]= y-t-d;
	dp[A1]= p+x+f; dp[A6]= p+x-f;
	dp[A2]= p-x+h; dp[A5]= p-x-h;
	}
	else dp[A0]= dp[A1]= dp[A2]= dp[A3]= dp[A4]= dp[A5]= dp[A6]= dp[A7]=0;
dp= wk;
ip= in;
for(i= 8 ; i-- ; dp+= Bd){
	double d0,d1,d2,d3,d4,d5,d6,d7;
	double y,p,t,x,b,d,f,h;
	Ul j,k,res;

	d0= dp[B0]; d1= dp[B1]; d2= dp[B2]; d3= dp[B3];
	d4= dp[B4]; d5= dp[B5]; d6= dp[B6]; d7= dp[B7];

	y= p= c0*d0+256.5; if(d4){ d4*=c0; y+= d4; p-= d4; }
	t= c2*d2; x= c6*d2; if(d6){ t+= c6*d6; x-= c2*d6; }

	b=d=f=h=0;
	if(d7){ b+= c7*d7; d+= -c1*d7; f+= -c5*d7; h+=  c3*d7; }
	if(d5){ b+= c5*d5; d+=  c3*d5; f+= -c1*d5; h+=  c7*d5; }
	if(d3){ b+= c3*d3; d+= -c5*d3; f+= -c7*d3; h+= -c1*d3; }
	if(d1){ b+= c1*d1; d+=  c7*d1; f+=  c3*d1; h+=  c5*d1; }

#ifdef Long64
	if(intra){
	k= (y+t)-b; Clip1(k); res = k<<56;
	k= (p+x)-f; Clip1(k); res|= k<<48;
	k= (p-x)-h; Clip1(k); res|= k<<40;
	k= (y-t)-d; Clip1(k); res|= k<<32;
	k= (y-t)+d; Clip1(k); res|= k<<24;
	k= (p-x)+h; Clip1(k); res|= k<<16;
	k= (p+x)+f; Clip1(k); res|= k<<8;
	k= (y+t)+b; Clip1(k); res|= k;
	} else {
	j= *p0;
	k= (j>>56    )+(int)((y+t)-b); Clip1(k); res = k<<56;
	k= (j>>48&255)+(int)((p+x)-f); Clip1(k); res|= k<<48;
	k= (j>>40&255)+(int)((p-x)-h); Clip1(k); res|= k<<40;
	k= (j>>32&255)+(int)((y-t)-d); Clip1(k); res|= k<<32;
	k= (j>>24&255)+(int)((y-t)+d); Clip1(k); res|= k<<24;
	k= (j>>16&255)+(int)((p-x)+h); Clip1(k); res|= k<<16;
	k= (j>> 8&255)+(int)((p+x)+f); Clip1(k); res|= k<<8;
	k= (    j&255)+(int)((y+t)+b); Clip1(k); res|= k;
		}
	*p0++ = res;
#else
	if(intra){
	k= (y-t)+d; Clip1(k); res = k<<S3;
	k= (p-x)+h; Clip1(k); res|= k<<S2;
	k= (p+x)+f; Clip1(k); res|= k<<S1;
	k= (y+t)+b; Clip1(k); res|= k<<S0;
	*p0++ = res;
	k= (y+t)-b; Clip1(k); res = k<<S3;
	k= (p+x)-f; Clip1(k); res|= k<<S2;
	k= (p-x)-h; Clip1(k); res|= k<<S1;
	k= (y-t)-d; Clip1(k); res|= k<<S0;
	*p0++ = res;
	} else {
	j= *p0;
	k= (j>>S3&255)+(int)((y-t)+d); Clip1(k); res = k<<S3;
	k= (j>>S2&255)+(int)((p-x)+h); Clip1(k); res|= k<<S2;
	k= (j>>S1&255)+(int)((p+x)+f); Clip1(k); res|= k<<S1;
	k= (j>>S0&255)+(int)((y+t)+b); Clip1(k); res|= k<<S0;
	*p0++ = res;
	j= *p0;
	k= (j>>S3&255)+(int)((y+t)-b); Clip1(k); res = k<<S3;
	k= (j>>S2&255)+(int)((p+x)-f); Clip1(k); res|= k<<S2;
	k= (j>>S1&255)+(int)((p-x)-h); Clip1(k); res|= k<<S1;
	k= (j>>S0&255)+(int)((y-t)-d); Clip1(k); res|= k<<S0;
	*p0++ = res;
		}
#endif
	}

}/* end of qdct() */

/*			13 level
 4.000  5.548  5.226  4.704  4.000  3.143  2.165  1.104 
 4.000  4.704  2.165 -1.104 -4.000 -5.548 -5.226 -3.143 
 4.000  3.143 -2.165 -5.548 -4.000  1.104  5.226  4.704 
 4.000  1.104 -5.226 -3.143  4.000  4.704 -2.165 -5.548 
 4.000 -1.104 -5.226  3.143  4.000 -4.704 -2.165  5.548 
 4.000 -3.143 -2.165  5.548 -4.000 -1.104  5.226 -4.704 
 4.000 -4.704  2.165  1.104 -4.000  5.548 -5.226  3.143 
 4.000 -5.548  5.226 -4.704  4.000 -3.143  2.165 -1.104 

     4      6      5      5      4      3      2      1 
     4      5      2     -1     -4     -6     -5     -3 
     4      3     -2     -6     -4      1      5      5 
     4      1     -5     -3      4      5     -2     -6 
     4     -1     -5      3      4     -5     -2      6 
     4     -3     -2      6     -4     -1      5     -5 
     4     -5      2      1     -4      6     -5      3 
     4     -6      5     -5      4     -3      2     -1 
*/

void
idct(int *s,Ul *p0,int intra,Ui cola)
{
int	y,p,*w,t,x;
int	d0,d1,d2,d3,d4,d5,d6,d7;
int	b,d,f,h;
int	i;
int	*s0;

w= s; s0= s;
for(;cola; s+= Ad, w+= Ad,cola>>=1)if(cola&1){
	d0= s[A0]; d1= s[A1]; d2= s[A2]; d3= s[A3];
	d4= s[A4]; d5= s[A5]; d6= s[A6]; d7= s[A7];

	y= p= d0<<2; if(d4){ d4<<=2; y+= d4; p-= d4; }
	t= 5*d2; x= d2<<1; if(d6){ t+= d6<<1; x-= 5*d6; }

	b=d=f=h=0;
	if(d7){ b+=   d7; d+= -6*d7; f+= -3*d7; h+=  5*d7; }
	if(d5){ b+= 3*d5; d+=  5*d5; f+= -6*d5; h+=    d5; }
	if(d3){ b+= 5*d3; d+= -3*d3; f+=   -d3; h+= -6*d3; }
	if(d1){ b+= 6*d1; d+=    d1; f+=  5*d1; h+=  3*d1; }

	w[A0]= y+t+b; w[A7]= y+t-b;
	w[A3]= y-t+d; w[A4]= y-t-d;
	w[A1]= p+x+f; w[A6]= p+x-f;
	w[A2]= p-x+h; w[A5]= p-x-h;
	}
w= s0;
s= s0;
for(i=8;i--; w+=Bd){
	Ul j,k,res;

	d0= w[B0]; d1= w[B1]; d2= w[B2]; d3= w[B3];
	d4= w[B4]; d5= w[B5]; d6= w[B6]; d7= w[B7];

	y= p= (d0<<2)+64; if(d4){ d4<<=2; y+= d4; p-= d4; }
	t= 5*d2; x= d2<<1; if(d6){ t+= d6<<1; x-= 5*d6; }

	b=d=f=h=0;
	if(d7){ b+=   d7; d+= -6*d7; f+= -3*d7; h+=  5*d7; }
	if(d5){ b+= 3*d5; d+=  5*d5; f+= -6*d5; h+=    d5; }
	if(d3){ b+= 5*d3; d+= -3*d3; f+=   -d3; h+= -6*d3; }
	if(d1){ b+= 6*d1; d+=    d1; f+=  5*d1; h+=  3*d1; }
#ifdef Long64
	if(intra){
	k= ((y+t)-b)>>7; Clip(k); res = k<<56;
	k= ((p+x)-f)>>7; Clip(k); res|= k<<48;
	k= ((p-x)-h)>>7; Clip(k); res|= k<<40;
	k= ((y-t)-d)>>7; Clip(k); res|= k<<32;
	k= ((y-t)+d)>>7; Clip(k); res|= k<<24;
	k= ((p-x)+h)>>7; Clip(k); res|= k<<16;
	k= ((p+x)+f)>>7; Clip(k); res|= k<<8;
	k= ((y+t)+b)>>7; Clip(k); res|= k;
	} else {
	j= *p0;
	k= (j>>56&255)+(((y+t)-b)>>7); Clip(k); res = k<<56;
	k= (j>>48&255)+(((p+x)-f)>>7); Clip(k); res|= k<<48;
	k= (j>>40&255)+(((p-x)-h)>>7); Clip(k); res|= k<<40;
	k= (j>>32&255)+(((y-t)-d)>>7); Clip(k); res|= k<<32;
	k= (j>>24&255)+(((y-t)+d)>>7); Clip(k); res|= k<<24;
	k= (j>>16&255)+(((p-x)+h)>>7); Clip(k); res|= k<<16;
	k= (j>> 8&255)+(((p+x)+f)>>7); Clip(k); res|= k<<8;
	k= (    j&255)+(((y+t)+b)>>7); Clip(k); res|= k;
		}
	*p0++ = res;
	}
#else
	if(intra){
	k= ((y-t)+d)>>7; Clip(k); res = k<<S3;
	k= ((p-x)+h)>>7; Clip(k); res|= k<<S2;
	k= ((p+x)+f)>>7; Clip(k); res|= k<<S1;
	k= ((y+t)+b)>>7; Clip(k); res|= k<<S0;
	*p0++ = res;
	k= ((y+t)-b)>>7; Clip(k); res = k<<S3;
	k= ((p+x)-f)>>7; Clip(k); res|= k<<S2;
	k= ((p-x)-h)>>7; Clip(k); res|= k<<S1;
	k= ((y-t)-d)>>7; Clip(k); res|= k<<S0;
	*p0++ = res;
	} else {
	j= *p0;
	k= (j>>S3&255)+(((y-t)+d)>>7); Clip(k); res = k<<S3;
	k= (j>>S2&255)+(((p-x)+h)>>7); Clip(k); res|= k<<S2;
	k= (j>>S1&255)+(((p+x)+f)>>7); Clip(k); res|= k<<S1;
	k= (j>>S0&255)+(((y+t)+b)>>7); Clip(k); res|= k<<S0;
	*p0++ = res;
	j= *p0;
	k= (j>>S3&255)+(((y+t)-b)>>7); Clip(k); res = k<<S3;
	k= (j>>S2&255)+(((p+x)-f)>>7); Clip(k); res|= k<<S2;
	k= (j>>S1&255)+(((p-x)-h)>>7); Clip(k); res|= k<<S1;
	k= (j>>S0&255)+(((y-t)-d)>>7); Clip(k); res|= k<<S0;
	*p0++ = res;
		}
	}
#endif
}

/*
**	variable precision idct
*/

#define S 2 /* 1-6 ok S=4: 47 level */
#define N (1<<S)
#define c1 (int)(1.3870398453221*N+.5)
#define c2 (int)(1.3065629648764*N+.5)
#define c3 (int)(1.1758756024194*N+.5)
#define c5 (int)(0.7856949583871*N+.5)
#define c6 (int)(0.5411961001462*N+.5)
#define c7 (int)(0.2758993792829*N+.5)
#define T (3+S+S)
#define E(x) (x)>>T

/*
vdct(s)
short	*s;
{
register int	v,u,y,p,*w,t,x;
register int	d0,d1,d2,d3,d4,d5,d6,d7;
int	i, wk[64];
short	*s0;

w= wk; s0= s;
for(i=8;i--; s+= 8, w+= 8){
	d0= s[0]; d1= s[1]; d2= s[2]; d3= s[3];
	d4= s[4]; d5= s[5]; d6= s[6]; d7= s[7];

	y= p= d0<<S; if(d4){ d4<<=S; y+= d4; p-= d4; }
	t= c2*d2; x= c6*d2; if(d6){ t+= c6*d6; x-= c2*d6; }

	if(d7){
	v= y+t; u= c1*d1+c3*d3+c5*d5+c7*d7; w[0]= v+u; w[7]= v-u;
	v= y-t; u= c7*d1-c5*d3+c3*d5-c1*d7; w[3]= v+u; w[4]= v-u;
	v= p+x; u= c3*d1-c7*d3-c1*d5-c5*d7; w[1]= v+u; w[6]= v-u;
	v= p-x; u= c5*d1-c1*d3+c7*d5+c3*d7; w[2]= v+u; w[5]= v-u;
	} else {
		if(d5){
		v= y+t; u= c1*d1+c3*d3+c5*d5; w[0]= v+u; w[7]= v-u;
		v= y-t; u= c7*d1-c5*d3+c3*d5; w[3]= v+u; w[4]= v-u;
		v= p+x; u= c3*d1-c7*d3-c1*d5; w[1]= v+u; w[6]= v-u;
		v= p-x; u= c5*d1-c1*d3+c7*d5; w[2]= v+u; w[5]= v-u;
		} else {
			if(d3){
			v= y+t; u= c1*d1+c3*d3; w[0]= v+u; w[7]= v-u;
			v= y-t; u= c7*d1-c5*d3; w[3]= v+u; w[4]= v-u;
			v= p+x; u= c3*d1-c7*d3; w[1]= v+u; w[6]= v-u;
			v= p-x; u= c5*d1-c1*d3; w[2]= v+u; w[5]= v-u;
			} else {
				if(d1){
				v= y+t; u= c1*d1; w[0]= v+u; w[7]= v-u;
				v= y-t; u= c7*d1; w[3]= v+u; w[4]= v-u;
				v= p+x; u= c3*d1; w[1]= v+u; w[6]= v-u;
				v= p-x; u= c5*d1; w[2]= v+u; w[5]= v-u;
				} else {
				w[0]= w[7]= y+t;
				w[3]= w[4]= y-t;
				w[1]= w[6]= p+x;
				w[2]= w[5]= p-x;
				}
			}
		}
	}
}
w= wk;
s= s0;
for(i=8;i--; s++, w++){
	d0= w[ 0]; d1= w[ 8]; d2= w[16]; d3= w[24];
	d4= w[32]; d5= w[40]; d6= w[48]; d7= w[56];

	y= p= (d0<<S)+(1<<(T-1)); if(d4){ d4<<=S; y+= d4; p-= d4; }
	t= c2*d2; x= c6*d2; if(d6){ t+= c6*d6; x-= c2*d6; }

	if(d7){
	v= y+t; u= c1*d1+c3*d3+c5*d5+c7*d7; s[ 0]= E(v+u); s[56]= E(v-u);
	v= y-t; u= c7*d1-c5*d3+c3*d5-c1*d7; s[24]= E(v+u); s[32]= E(v-u);
	v= p+x; u= c3*d1-c7*d3-c1*d5-c5*d7; s[ 8]= E(v+u); s[48]= E(v-u);
	v= p-x; u= c5*d1-c1*d3+c7*d5+c3*d7; s[16]= E(v+u); s[40]= E(v-u);
	} else {
		if(d5){
		v= y+t; u= c1*d1+c3*d3+c5*d5; s[ 0]= E(v+u); s[56]= E(v-u);
		v= y-t; u= c7*d1-c5*d3+c3*d5; s[24]= E(v+u); s[32]= E(v-u);
		v= p+x; u= c3*d1-c7*d3-c1*d5; s[ 8]= E(v+u); s[48]= E(v-u);
		v= p-x; u= c5*d1-c1*d3+c7*d5; s[16]= E(v+u); s[40]= E(v-u);
		} else {
			if(d3){
		v= y+t; u= c1*d1+c3*d3; s[ 0]= E(v+u); s[56]= E(v-u);
		v= y-t; u= c7*d1-c5*d3; s[24]= E(v+u); s[32]= E(v-u);
		v= p+x; u= c3*d1-c7*d3; s[ 8]= E(v+u); s[48]= E(v-u);
		v= p-x; u= c5*d1-c1*d3; s[16]= E(v+u); s[40]= E(v-u);
			} else {
				if(d1){
			v= y+t; u= c1*d1; s[ 0]= E(v+u); s[56]= E(v-u);
			v= y-t; u= c7*d1; s[24]= E(v+u); s[32]= E(v-u);
			v= p+x; u= c3*d1; s[ 8]= E(v+u); s[48]= E(v-u);
			v= p-x; u= c5*d1; s[16]= E(v+u); s[40]= E(v-u);
				} else {
				s[ 0]= s[56]= E(y+t);
				s[24]= s[32]= E(y-t);
				s[ 8]= s[48]= E(p+x);
				s[16]= s[40]= E(p-x);
				}
			}
		}
	}
}}
*/

