/*
**
**	mc.c
**
*/

#include	"mpeg.h"
#define Rd 1

#ifdef Long64
static Ul p1=  257L<<48 | 257L<<32 | 257L<<16 | 257L;
static Ul n1=~(257L<<48 | 257L<<32 | 257L<<16 | 257L);
#endif

#ifdef Int32
static Ui p1=  257<<16 | 257;
static Ui n1=~(257<<16 | 257);
#endif

#ifdef LE
#define Sift(a,b,s,t) ((a)<<(s)|(b)>>(t))
#else
#define Sift(a,b,s,t) ((a)>>(s)|(b)<<(t))
#endif

#ifdef Long64
void
pred3(Uc *yp,Uc *tp0,int sz)
	{
	int y,t,s;	
	Ul a,b,c,d,e,es,f,fs;
	Ul *lp;
	Ul *tp= (Ul*)tp0;

	sz>>=3;
	if((t= (Ul)yp&7)){
		yp-= t;
		t<<=3;
		s= 64-t;
		lp= (Ul *)yp;

		if(t<56){
			c= *lp; d = *(lp+1);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			f = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs= (f&n1)>>1;

			y= 8; do {
				lp+=sz;
				c= *lp; d = *(lp+1);
				b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;

				*tp++ = es + fs +((e|f)&p1) ;
				f= e; fs= es;
				}while(--y);
			}
		else{
			a = *(lp+1);
			b= Sift(a,*lp,8,56);
			f = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs= (f&n1)>>1;

			y= 8; do {
				lp+=sz;
				a = *(lp+1);
				b= Sift(a,*lp,8,56);
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;

				*tp++ = es + fs +((e|f)&p1) ;
				f= e; fs= es;
				}while(--y);
			}
		}
	else {
		lp = (Ul *)yp;
		b  = *lp; a= *(lp+1);
		a= Sift(a,b,56,8);
		f = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
		fs= (f&n1)>>1;

		y= 8; do {
			lp+=sz;
			b  = *lp; a= *(lp+1);
			a= Sift(a,b,56,8);
			e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			es= (e&n1)>>1;

			*tp++ = es + fs +((e|f)&p1) ;
			f= e; fs= es;
			}while(--y);
		}
	}
#else
#ifdef Int32
void
pred3(Uc *yp,Uc *tp0,int sz)
{
	int y,t,s;	
	Ui a,b,c,d,e,es,f0,fs0,f1,fs1;
	Ui *lp;
	Ul *tp= (Ul*)tp0;

	sz>>=2;
	if((t= (Ul)yp&3)){
		yp-= t;
		t<<=3;
		s= 32-t;
		lp= (Ui *)yp;
		if(t<24){
			c= *lp; d = *(lp+1);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			f0 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs0= (f0&n1)>>1;

			c= d; d = *(lp+2);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			f1 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs1= (f1&n1)>>1;

			for (y=8;y--;){
				lp+=sz;
				c= *lp; d = *(lp+1);
				b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;
				*tp++ = es + fs0 +((e|f0)&p1) ;
				f0= e; fs0= es;

				c= d; d = *(lp+2);
				b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;
				*tp++ = es + fs1 +((e|f1)&p1) ;
				f1= e; fs1= es;
				}
			}
		else{
			a = *(lp+1); b= *lp;
			b= Sift(a,b,8,24);
			f0 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs0= (f0&n1)>>1;

			c= *(lp+2);
			b= Sift(c,a,8,24);
			a= c;
			f1 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			fs1= (f1&n1)>>1;

			for (y=8;y--;){
				lp+=sz;
				a = *(lp+1);
				b= Sift(a,*lp,8,24);
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;

				*tp++ = es + fs0 +((e|f0)&p1) ;
				f0= e; fs0= es;

				c = *(lp+2);
				b= Sift(c,a,8,24);
				a = c;
				e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
				es= (e&n1)>>1;

				*tp++ = es + fs1 +((e|f1)&p1) ;
				f1= e; fs1= es;
				}
			}
		}
	else {
		lp = (Ui *)yp;
		b = *lp; c= *(lp+1);
		a= Sift(c,b,24,8);
		f0 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
		fs0= (f0&n1)>>1;

		b = c; c= *(lp+2);
		a= Sift(c,b,24,8);
		f1 = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
		fs1= (f1&n1)>>1;
		for (y=8;y--;){
			lp+=sz;
			b = *lp; c= *(lp+1);
			a= Sift(c,b,24,8);
			e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			es= (e&n1)>>1;
			*tp++ = es + fs0 +((e|f0)&p1) ;
			f0= e; fs0= es;

			b = c; c= *(lp+2);
			a= Sift(c,b,24,8);
			e = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			es= (e&n1)>>1;
			*tp++ = es + fs1 +((e|f1)&p1) ;
			f1= e; fs1= es;
			}
		}
}
#else
void
pred3(Uc *yp,Uc *tp0,int sz)
{
	Ui a,c,y,t;
	Uc *xp;
	int *tp= (int*)tp0;
	xp= yp+sz;
	for (y=0;y<8;y++){
#ifdef LE
		a= *(yp+8)+*(xp+8)+2*Rd;
		c= *(yp+7)+*(xp+7);		t=  (a+c)>>2; t<<=8;
		a= *(yp+6)+*(xp+6)+2*Rd;	t|= (a+c)>>2; t<<=8;
		c= *(yp+5)+*(xp+5);		t|= (a+c)>>2; t<<=8;
		a= *(yp+4)+*(xp+4)+2*Rd;	t|= (a+c)>>2;*(tp+1)=t;
		c= *(yp+3)+*(xp+3);		t=  (a+c)>>2; t<<=8;
		a= *(yp+2)+*(xp+2)+2*Rd;	t|= (a+c)>>2; t<<=8;
		c= *(yp+1)+*(xp+1);		t|= (a+c)>>2; t<<=8;
		a= *yp+*xp+2*Rd;		t|= (a+c)>>2;*tp=t;
#else
		a= *yp+*xp+2*Rd;
		c= *(yp+1)+*(xp+1);		t=  (a+c)>>2; t<<=8;
		a= *(yp+2)+*(xp+2)+2*Rd;	t|= (a+c)>>2; t<<=8;
		c= *(yp+3)+*(xp+3);		t|= (a+c)>>2; t<<=8;
		a= *(yp+4)+*(xp+4)+2*Rd;	t|= (a+c)>>2;*tp= t;
		c= *(yp+5)+*(xp+5);		t=  (a+c)>>2; t<<=8;
		a= *(yp+6)+*(xp+6)+2*Rd;	t|= (a+c)>>2; t<<=8;
		c= *(yp+7)+*(xp+7);		t|= (a+c)>>2; t<<=8;
		a= *(yp+8)+*(xp+8)+2*Rd;	t|= (a+c)>>2;*(tp+1)=t;
#endif
		yp= xp;
		xp+= sz;
		tp+= 2;
	}
}
#endif
#endif


#ifdef Long64
void
pred2(Uc *yp,Uc *tp0,int sz)
{
	int y,t,s;	
	Ul a,b,c,d,*lp;
	Ul *tp= (Ul*)tp0;

	sz>>=3;
	if((t= (Ul)yp&7)){
		yp-= t;
		t<<=3;
		s= 64-t;
		lp= (Ul *)yp;
		if(t<56) { y=8; do{
			c= *lp; d= *(lp+1);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1);
			lp+=sz;
			}while(--y);
		}
		else { y=8;do{
			a = *(lp+1); b= *lp; b= Sift(a,b,8,56);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			lp+=sz;
			}while(--y);
		}
	}
	else {
		lp = (Ul *)yp;
		y=8;do{
			a = *lp; b= *(lp+1); b= Sift(b,a,56,8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			lp+=sz;
		}while(--y);
	}
}
#else
#ifdef Int32
void
pred2(Uc *yp,Uc *tp0,int sz)
{
	int y,t,s;	
	Ui a,b,c,d;
	Ui *lp;
	Ui *tp= (Ui*)tp0;

	sz>>=2;
	if((t= (Ul)yp&3)){
		yp-= t;
		t<<= 3;
		s= 32-t;

		lp= (Ui *)yp;
		if(t<24) for (y=8;y--;){
			c= *lp; d = *(lp+1);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			c= d; d = *(lp+2);
			b= Sift(d,c,s,t); a= Sift(d,c,s-8,t+8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			lp+=sz;
		}
		else for (y=8;y--;){
			b = *(lp+1);
			a= Sift(b,*lp,8,24);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			c = *(lp+2);
			a= Sift(c,b,8,24);
			b= c;
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			lp+=sz;
		}
	} else {
		lp = (Ui *)yp;
		for (y=8;y--;){
			a = *lp; c= *(lp+1);
			b= Sift(c,a,24,8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			a = c;
			b= Sift(*(lp+2),a,24,8);
			*tp++ = ((a&n1)>>1)+ ((b&n1)>>1) +((a|b)&p1) ;
			lp+=sz;
		}
	}
}
#else
void
pred2(Uc *yp,Uc *tp0,int sz)
{
	Ui a,c,y,t;
	int *tp= (int*)tp0;
	for (y=8;y--;){
#ifdef LE
		a= *(yp+8);
		c= *(yp+7)+Rd;	t=  (a+c)>>1; t<<=8;
		a= *(yp+6);	t|= (a+c)>>1; t<<=8;
		c= *(yp+5)+Rd;	t|= (a+c)>>1; t<<=8;
		a= *(yp+4);	t|= (a+c)>>1;*(tp+1)=t;
		c= *(yp+3)+Rd;	t=  (a+c)>>1; t<<=8;
		a= *(yp+2);	t|= (a+c)>>1; t<<=8;
		c= *(yp+1)+Rd;	t|= (a+c)>>1; t<<=8;
		a= *yp;		t|= (a+c)>>1;*tp= t;
#else
		a= *yp;
		c= *(yp+1)+Rd;	t=  (a+c)>>1; t<<=8;
		a= *(yp+2);	t|= (a+c)>>1; t<<=8;
		c= *(yp+3)+Rd;	t|= (a+c)>>1; t<<=8;
		a= *(yp+4);	t|= (a+c)>>1;*tp= t;
		c= *(yp+5)+Rd;	t=  (a+c)>>1; t<<=8;
		a= *(yp+6);	t|= (a+c)>>1; t<<=8;
		c= *(yp+7)+Rd;	t|= (a+c)>>1; t<<=8;
		a= *(yp+8);	t|= (a+c)>>1;*(tp+1)= t;
#endif
		yp+= sz;
		tp+= 2;
	}
}
#endif
#endif

#ifdef Long64
void
pred1(Uc *yp,Uc *tp0,int sz)
{
	int y,t,s;	
	Ul a,b,bs,as;
	Ul *lp;
	Ul *tp=(Ul*)tp0;

	sz>>=3;
	if((t= (Ul)yp&7)){
		yp-= t;
		t<<=3;
		s= 64-t;
		lp= (Ul *)yp;
		b= Sift(*(lp+1),*lp,s,t);
		bs = (b&n1)>>1;
		y=8;do{
			lp+=sz;
			a= Sift(*(lp+1),*lp,s,t);
			as= (a&n1)>>1;
			*tp++ = as + bs +((a|b)&p1) ;
			b= a; bs= as;
		}while(--y);
	} else {
		lp= (Ul *)yp;
		b = *lp; bs= (b&n1)>>1;
		y=8;do{
			lp+=sz;
			a= *lp; as= (a&n1)>>1;
			*tp++ = as + bs +((a|b)&p1) ;
			b= a; bs= as;
		}while(--y);
	}
}
#else
#ifdef Int32
void
pred1(Uc *yp,Uc *tp0,int sz)
{
	int y,t,s;	
	Ui a,as,b1,b2,bs1,bs2,*ip,tt;
	Ui *tp= (Ui*)tp0;

	sz>>=2;
	if((t= (Ul)yp&3)){
		yp-= t;
		t<<= 3;
		s= 32-t;
		ip= (Ui *)yp;
		tt= *(ip+1);
		b1= Sift(tt,*ip,s,t); b2= Sift(*(ip+2),tt,s,t);
		bs1 = (b1&n1)>>1; bs2 = (b2&n1)>>1;

		for (y=8;y--;){
			ip+=sz;
			tt= *(ip+1);
			a= Sift(tt,*ip,s,t);
			as= (a&n1)>>1;
			*tp++ = as + bs1 +((a|b1)&p1);
			b1= a; bs1= as;
			a= Sift(*(ip+2),tt,s,t);
			as= (a&n1)>>1;
			*tp++ = as + bs2 +((a|b2)&p1);
			b2= a; bs2= as;
		}
	} else {
		ip= (Ui *)yp;
		b1 = *ip;	bs1= (b1&n1)>>1;
		b2 = *(ip+1);	bs2= (b2&n1)>>1;

		for (y=8;y--;){
			ip+=sz;
			a = *ip; as= (a&n1)>>1;
			*tp++ = as+ bs1 +((a|b1)&p1);
			b1= a; bs1= as;

			a = *(ip+1); as= (a&n1)>>1;
			*tp++ = as+ bs2 +((a|b2)&p1);
			b2= a; bs2= as;
		}
	}
}
#else
void
pred1(Uc *yp,Uc *tp,int sz)
{
	int a,c,x;
	Uc *xp;

	for (x=0;x<8;x++){
		xp= yp;
		a= *xp;
		c= *(xp+=sz)+Rd;*tp     = (a+c)>>1;
		a= *(xp+=sz);   *(tp+8) = (a+c)>>1;
		c= *(xp+=sz)+Rd;*(tp+16)= (a+c)>>1;
		a= *(xp+=sz);   *(tp+24)= (a+c)>>1;
		c= *(xp+=sz)+Rd;*(tp+32)= (a+c)>>1;
		a= *(xp+=sz);   *(tp+40)= (a+c)>>1;
		c= *(xp+=sz)+Rd;*(tp+48)= (a+c)>>1;
		a= *(xp+=sz);   *(tp+56)= (a+c)>>1;
		yp++;
		tp++;
	}
}
#endif
#endif

#ifdef Long64
void
pred0(Uc *yp,Uc *tp0,int sz)
{
	int t,s;	
	Ul *lp;
	Ul *tp= (Ul*)tp0;
	sz>>=3;
	if((t= (Ul)yp&7)){
		yp-= t;
		t<<=3;
		s= 64-t;
		lp= (Ul *)yp;
#ifdef LE
		*tp     = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+1) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+2) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+3) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+4) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+5) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+6) = *lp>>t | *(lp+1)<<s; lp+= sz;
		*(tp+7) = *lp>>t | *(lp+1)<<s;
#else
		*tp     = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+1) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+2) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+3) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+4) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+5) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+6) = *lp<<t | *(lp+1)>>s; lp+= sz;
		*(tp+7) = *lp<<t | *(lp+1)>>s;
#endif
	} else {
		lp= (Ul *)yp;
		*tp     = *lp; lp+= sz;
		*(tp+1) = *lp; lp+= sz;
		*(tp+2) = *lp; lp+= sz;
		*(tp+3) = *lp; lp+= sz;
		*(tp+4) = *lp; lp+= sz;
		*(tp+5) = *lp; lp+= sz;
		*(tp+6) = *lp; lp+= sz;
		*(tp+7) = *lp; 
	}
}
#else
#ifdef Int32
void
pred0(Uc *yp,Uc *tp0,int sz)
{
	register int t,s;	
	register Ui *ip;
	Ui *tp= (Ui*)tp0;
	sz>>=2;
	if((t= (Ul)yp&3)){
	register Ui r;
		yp-= t;
		t<<= 3;
		s= 32-t;
		ip= (Ui *)yp;
#ifdef LE
	r= *(ip+1); *tp     = *ip>>t | r<<s; *(tp+1) = r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+2) = *ip>>t | r<<s; *(tp+3) = r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+4) = *ip>>t | r<<s; *(tp+5) = r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+6) = *ip>>t | r<<s; *(tp+7) = r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+8) = *ip>>t | r<<s; *(tp+9) = r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+10)= *ip>>t | r<<s; *(tp+11)= r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+12)= *ip>>t | r<<s; *(tp+13)= r>>t | *(ip+2)<<s; ip+=sz;
	r= *(ip+1); *(tp+14)= *ip>>t | r<<s; *(tp+15)= r>>t | *(ip+2)<<s;
#else
	r= *(ip+1); *tp     = *ip<<t | r>>s; *(tp+1) = r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+2) = *ip<<t | r>>s; *(tp+3) = r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+4) = *ip<<t | r>>s; *(tp+5) = r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+6) = *ip<<t | r>>s; *(tp+7) = r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+8) = *ip<<t | r>>s; *(tp+9) = r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+10)= *ip<<t | r>>s; *(tp+11)= r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+12)= *ip<<t | r>>s; *(tp+13)= r<<t | *(ip+2)>>s; ip+=sz;
	r= *(ip+1); *(tp+14)= *ip<<t | r>>s; *(tp+15)= r<<t | *(ip+2)>>s;
#endif
	} else {
		ip= (Ui *)yp;
		*tp     = *ip; *(tp+ 1)= *(ip+1); ip+=sz;
		*(tp+ 2)= *ip; *(tp+ 3)= *(ip+1); ip+=sz;
		*(tp+ 4)= *ip; *(tp+ 5)= *(ip+1); ip+=sz;
		*(tp+ 6)= *ip; *(tp+ 7)= *(ip+1); ip+=sz;
		*(tp+ 8)= *ip; *(tp+ 9)= *(ip+1); ip+=sz;
		*(tp+10)= *ip; *(tp+11)= *(ip+1); ip+=sz;
		*(tp+12)= *ip; *(tp+13)= *(ip+1); ip+=sz;
		*(tp+14)= *ip; *(tp+15)= *(ip+1);
	}
}
#else
void
pred0(Uc *yp,Uc *tp0,int sz)
{
	int a,y;
	int *tp= (int*)tp0;
	for (y=8;y--;){
#ifdef LE
		a= *(yp+7);
		a<<=8; a|= *(yp+6);
		a<<=8; a|= *(yp+5);
		a<<=8; a|= *(yp+4);
		*(tp+1)= a;
		a= *(yp+3);
		a<<=8; a|= *(yp+2);
		a<<=8; a|= *(yp+1);
		a<<=8; a|= *yp;
		*tp= a;
#else
		a= *yp;
		a<<=8; a|= *(yp+1);
		a<<=8; a|= *(yp+2);
		a<<=8; a|= *(yp+3);
		*tp= a;
		a= *(yp+4);
		a<<=8; a|= *(yp+5);
		a<<=8; a|= *(yp+6);
		a<<=8; a|= *(yp+7);
		*(tp+1)= a;
#endif
		yp+=sz; tp+=2;
	}
}
#endif
#endif

void
mc_mb(Uc *img,int h,int v,MV mv,Uc *tp)
{
	int	hp,sz,cbr;
	Uc	*op;

	if(img==NULL)return;

	sz= hs;
	if(mv.y==0){
		if(mv.x==0){
		op= img+v*sz+h;
		pred0(op,tp,sz); pred0(op+8,tp+64,sz); op+= sz<<3;
		pred0(op,tp+128,sz); pred0(op+8,tp+192,sz);
		op= img+vhs+(v*sz>>2)+(h>>1);
		pred0(op,tp+256,sz>>1); pred0(op+(vhs>>2),tp+320,sz>>1);
		return;
		}
		op= img+v*sz+h+(mv.x>>1);
		if(mv.x&1){
			pred2(op,tp,sz);	pred2(op+8,tp+64,sz); op+= sz<<3;
			pred2(op,tp+128,sz);	pred2(op+8,tp+192,sz);
		} else {
			pred0(op,tp,sz);	pred0(op+8,tp+64,sz); op+= sz<<3;
			pred0(op,tp+128,sz);	pred0(op+8,tp+192,sz);
			}
		h >>=1; v >>= 1;
		mv.x/=2; h+= mv.x>>1; sz>>=1;
		op= img+vhs+v*sz+h;
		cbr= vhs>>2;
		if(mv.x&1){
			pred2(op,tp+256,sz); pred2(op+cbr,tp+320,sz);
		} else {
			pred0(op,tp+256,sz); pred0(op+cbr,tp+320,sz);
		}
		return;
	}

	hp= ((mv.x&1)<<1) | (mv.y&1);
	op= img+(v+(mv.y>>1))*sz + h+(mv.x>>1);

	switch(hp){
	case 3: pred3(op,tp,sz);	pred3(op+8,tp+64,sz); op+= sz<<3;
		pred3(op,tp+128,sz);	pred3(op+8,tp+192,sz); break;
	case 2: pred2(op,tp,sz);	pred2(op+8,tp+64,sz); op+= sz<<3;
		pred2(op,tp+128,sz);	pred2(op+8,tp+192,sz); break;
	case 1: pred1(op,tp,sz);	pred1(op+8,tp+64,sz); op+= sz<<3;
		pred1(op,tp+128,sz);	pred1(op+8,tp+192,sz); break;
	case 0: pred0(op,tp,sz);	pred0(op+8,tp+64,sz); op+= sz<<3;
		pred0(op,tp+128,sz);	pred0(op+8,tp+192,sz);
	}
	h >>=1; v >>= 1;
	mv.x/=2; mv.y/=2;
	hp= ((mv.x&1)<<1) | (mv.y&1);
	h+= mv.x>>1; v+= mv.y>>1;
	sz>>=1;
	op= img+vhs+v*sz+h;
	cbr= vhs>>2;

	switch(hp){
	case 3: pred3(op,tp+256,sz); pred3(op+cbr,tp+320,sz); break;
	case 2: pred2(op,tp+256,sz); pred2(op+cbr,tp+320,sz); break;
	case 1: pred1(op,tp+256,sz); pred1(op+cbr,tp+320,sz); break;
	case 0: pred0(op,tp+256,sz); pred0(op+cbr,tp+320,sz);
	}
}
