/* 
**	mpeg.h
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>
#include <string.h>
#include <fcntl.h>
#include <setjmp.h>
#include <unistd.h>

//#define Debug

#ifndef Debug
#define pr 0
#define prsl 0
#define pri 0
#define prp 0
#define prb 0
#define prd 0
#define prdc 0
#define	prrl 0
#define prcbp 0
#define prc 0
#define error_detect 0
#define fld(a,b) fld(a)
#endif

//#define NMVT

typedef unsigned char  Uc;
typedef unsigned short Us;
typedef unsigned int   Ui;
typedef unsigned long  Ul;

struct mv{ int x; int y; };
typedef struct mv MV;

struct clp{
Ui mr[256]; Ui r[512];
Ui mg[256]; Ui g[512];
Ui mb[256]; Ui b[512];	/* rgb dither */
Ui my[256]; Ui y[512];
Ui mu[256]; Ui u[512];
Ui mv[256]; Ui v[512];	/* yuv dither */
Ui mq[256]; Ui sq[512];	/* square */
Ui mc[256]; Ui cl[512];	/* [0.255] clip */
	};
typedef struct clp Clp;

extern int	Zz[64];
/*
 * VLC lenght tables
 */
extern int	VlcMBA[35];	/* VLC length table for MBA */
extern int	 CdMBA[35];	/* VLC code   table for MBA */
extern int	VlcBT0[4];	/* VLC length table for BT0 */
extern int	 CdBT0[4];	/* VLC code   table for BT0 */
extern int	VlcBT1[7];	/* VLC length table for BT1 */
extern int	 CdBT1[7];	/* VLC code   table for BT1 */
extern int	VlcBT2[11];	/* VLC length table for BT2 */
extern int	 CdBT2[11];	/* VLC code   table for BT2 */
extern int	VlcMVH[16];	/* VLC length table for MV  */
extern int	 CdMVH[16];	/* VLC code   table for MV  */
extern int	VlcCBP[64];	/* VLC length table for CBP */
extern int	 CdCBP[64];	/* VLC code   table for CBP */

extern Ui buf;
extern char *fsif, *bsif, *osif, *out;
extern Uc diqm[64];
extern Uc iqm[64];
extern Uc nqm[64];
extern int ptyp;

/* for enc-dec debug */
#ifdef Debug
extern int 	pr,prsl;
extern int	pri,prp,prb,prd;
extern int 	prcbp,prdc,prrl;
extern int 	prc,error_detect;
#endif

extern int	ffp,bfp;
extern int	Len[113],Cod[113],Run[113],Lev[113];
extern int	lasty,lastu,lastv;
extern jmp_buf	jpb;

/*
**	display control globals
*/
extern int	dhs,dvs,hs,vs,vhs;
extern int	x2;
extern int	ddt;
extern int	bgc;
extern int	cmp;
extern int	pdct;
extern int	lastpt;
extern int	sync1;
extern int	wid;
extern int	times;
extern int	etimes;
extern int	length;
extern int	sysbs;
extern int	srsqh;
extern int	broken_link2;
extern long	flen;
extern Ui	bs8;
extern FILE	*bs;
extern Uc	mba0[16];
extern Uc	mba1[256];
extern Uc	cbpt[256];
extern Uc	cbpt2[8];
extern Uc	mvht[256];
extern Uc	mbtt[3][64];
void mc_mb(Uc *img,int h,int v,MV mv,Uc *tp);
void save(int v,int h,Ul *pp);
void mcsel(int h,int v,MV vp,MV vn,Ul *pre,int dir);
void blocklayer(int mb,int intra,int qp,Uc pre[6][64]);
void init_rlt(void);
int vld(int *tcde,int *tbit,int maxi,char *tname);
int fld(int bit,char *cp);
void qdct(int *in,Ul *p0,int intra,Ui cola);
void idct(int *s,Ul *p0,int intra,Ui cola);
void post(Uc *sif,int dx,int dy);
void disp(int, Uc *sif, int, int);
void expand(Uc *p1,Ui *q,int wx,int wy,int lbp,Ui *z);
void color_map_set();
void mkgrid(void);
void events(void);



