/*
**	wtf.c
*/
#include "mpeg.h"
#include "disp.h"
#define SIFout


#ifdef SIFout

wtf(name,fr,sif)
char *name;
char *sif;
	{
	int	i,j;
	int	k,l,nl,cr;

	char wfname[100];
	sprintf(wfname,"%s%05d.sif",name,fr);
	ffw(wfname,sif,vhs+(vhs>>1));
	}

#else	/* not SIFout */

/*
 *	wtf(n,fr,sif)
 *
 *	destination file: 	file1.yuv
 *	+-------------------------------+  ^  Top and bottom 99 lines
 *	|UYVYUYVYUYVYUY...VYUYVYUYVYUYVY|  |     (approximately)
 *	|UYVYUYVYUYVYUY...VYUYVYUYVYUYVY|  |  are filled by black.
 *	|.......... ............... ....| 486
 *	|UYVYUYVYUYVYUY...VYUYVYUYVYUYVY|  |
 *	|UYVYUYVYUYVYUY...VYUYVYUYVYUYVY|  |
 *	+-------------------------------+  v
 *	<------- 720 + 360 + 360 ------->
 *
 *	+---------------+ ^
 *	|YYYYYY     YYYY| |240 or 480
 *	|YYYYYY     YYYY| |
 *	+---------------+ v
 *	|UUUUUU| 120 or 240
 *	+------+
 *	|VVVVVV| 120 or 240
 *	<----- 704 ----->
 *	  352 
 */
#define LL 1440
#define LN 486
#define SX 352
#define SY 240
#define SCX (SX/2)
#define SCY (SY/2)
typedef struct {
	Uc y[SY][SX];
	Uc c[2][SCY][SCX];
}SIF;
Uc	im[LN][LL];

wtf(name,fr,sif)
char *name;
SIF *sif;
	{
	int	i,j;
	int	k,l,nl,cr;

	char wfname[100];
	/*
	sprintf(wfname,"%s%05d.yuv",name,fr);
	*/
	sprintf(wfname,"dec%05d.yuv",fr);

	for(j=0;j<3;j++)
	for(i=0;i<LL;i+=2){ im[j][i]=128; im[j][i+1]=0;}
	for(j=LN-3;j<LN;j++)
	for(i=0;i<LL;i+=2){ im[j][i]=128; im[j][i+1]=0;}

	for(j=0;j<LN;j++)
	for(i=0;i<16;i+=2){ im[j][i]=128; im[j][i+1]=0;}
	for(j=0;j<LN;j++)
	for(i=LL-32;i<LL;i+=2){ im[j][i]=128; im[j][i+1]=0;}

	/* Y horizontal */
	for(i=0,l=16+1;i<SX;i++,l+=4){
		int i1,i2,i3;
		i1=i-1;
		i2=i+1;
		i3=i+2;
		if(i1<0)i1=i; 
		if(i2>=SX)i2=SX-1;
		if(i3>=SX)i3=SX-1;
		for(j=0,k=3;j<SY;j++,k+=2){
			int t;
			im[k][l]= sif->y[j][i];
			t= ( 140*(sif->y[j][i] +sif->y[j][i2])
			     -12*(sif->y[j][i1]+sif->y[j][i3])+128 )>>8;
			if(t>=512)t=0;
			else if(t>255)t=255;
			im[k][l+2]= t;
			}
		}
	/* UV horizontal  */
	for(cr=0;cr<2;cr++){
		nl= cr<<1;
		for(i=0,l=16+nl;i<SCX;i++,l+=8){
			int	i1,i2,i3;
			i1=i-1;
			i2=i+1;
			i3=i+2;
			if(i1<0)i1=i; 
			if(i2>=SCX)i2=SCX-1;
			if(i3>=SCX)i3=SCX-1;
			for(j=0,k=3;j<SCY;j++,k+=4){
				int	t;
				im[k][l]= sif->c[cr][j][i];
				t= ( 140*(sif->c[cr][j][i] +sif->c[cr][j][i2])
				     -12*(sif->c[cr][j][i1]+sif->c[cr][j][i3])+128 )>>8;
				if(t>=512)t=0;
				else if(t>255)t=255;
				im[k][l+4]= t;
				}
			}
		}
	/* UV vertical */
	for(j=3;j<LN-3;j+=4){
		int	j1,j2,j3;
		j1=j-4;
		j2=j+4;
		j3=j+8;
		if(j1<3)j1=3;
		if(j2>=LN-3)j2=LN-7;
		if(j3>=LN-3)j3=LN-7;
		for(i=16;i<LL-16;i+=2){
			int	t;
			t= ( 140*(im[j][i] +im[j2][i])
			     -12*(im[j1][i]+im[j3][i])+128 )>>8;
			if(t>=512)t=0;
			else if(t>255)t=255;
			im[j+2][i]= t;
			}
		}
	/* UYVY vertical */
	for(j=3;j<LN-3;j+=2){
		int	j1,j2,j3;
		j1=j-2;
		j2=j+2;
		j3=j+4;
		if(j1<3)j1=3;
		if(j2>=LN-3)j2=LN-5;
		if(j3>=LN-3)j3=LN-5;
		for(i=16;i<LL-16;i++){
			int	t;
			t= ( 140*(im[j][i] +im[j2][i])
			     -12*(im[j1][i]+im[j3][i])+128 )>>8;
			if(t>=512)t=0;
			else if(t>255)t=255;
			im[j+1][i]= t;
			}
		}
	ffw(wfname,im,sizeof(im));
	}
#endif	/* endof not SIFout */

ffw(name,p,size) char *name; char *p; long size;
	{
	int	fd;
	if((fd=open(name,O_WRONLY|O_CREAT|O_TRUNC,0666))<0){
		fprintf(stderr,"%s open error \n",name); exit(1); }
	if((write(fd,p,size))<0) { fprintf(stderr,"%s write error\n",name); exit(1); }
	close(fd);
	}
